UpgradeList = LibStub("AceAddon-3.0"):NewAddon("UpgradeList", "AceConsole-3.0", "AceEvent-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("UpgradeList")

UPGRADELIST_VERSION = "0.2";
UPGRADELIST_SELECTEDBOSS = nil;
UPGRADELIST_SELECTEDINSTANCE = nil;
UPGRADELIST_SELECTEDDIFFICULTY = nil;

local UpgradeListLDB = LibStub("LibDataBroker-1.1"):NewDataObject("UpgradeList", {
	type = "launcher",
	icon = "Interface\\Icons\\Achievement_Dungeon_ClassicDungeonMaster",
	OnClick = function(frame, msg)
		if msg == "LeftButton" then
			UpgradeList:OpenUpgradeList()
		elseif msg == "RightButton" then
			InterfaceOptionsFrame_OpenToCategory(UpgradeList.optionsFrame)
		end
	end,

})

local icon = LibStub("LibDBIcon-1.0")

local options = {
	name = "UpgradeList",
	handler = UpgradeList,
	type = 'group',
	args = {
		togglebutton = { 
			type = "execute",
			name = "Open Upgrade List",
			desc = "This button will Open the UpgradeList addon.",
			func = "OpenUpgradeList",
		},
	},
}

local defaults = { 
	char = {
		PrimarySpecList = {
			Head = {
				Row = { },
				Count = 1,
			},
			Neck = {
				Row = {	},
				Count = 1,
			},
			Shoulder = {
				Row = {	},
				Count = 1,
			},
			Back = {
				Row = {	},
				Count = 1,
			},
			Chest = {
				Row = {	},
				Count = 1,
			},
			Wrist = {
				Row = {	},
				Count = 1,
			},
			Hand = {
				Row = {	},
				Count = 1,
			},
			Waist = {
				Row = {	},
				Count = 1,
			},
			Leg = {
				Row = {	},
				Count = 1,
			},
			Foot = {
				Row = {	},
				Count = 1,
			},
			Ring = {
				Row = {	},
				Count = 1,
			},
			Trinket = {
				Row = {	},
				Count = 1,
			},
			Main = {
				Row = {	},
				Count = 1,
			},
			Off = {
				Row = {	},
				Count = 1,
			},
			Ranged = {
				Row = {	},
				Count = 1,
			},
			Other = {
				Row = {	},
				Count = 1,
			},
		},
		SecondarySpecList = {
			Head = {
				Row = {	},
				Count = 1,
			},
			Neck = {
				Row = {	},
				Count = 1,
			},
			Shoulder = {
				Row = {	},
				Count = 1,
			},
			Back = {
				Row = {	},
				Count = 1,
			},
			Chest = {
				Row = {	},
				Count = 1,
			},
			Wrist = {
				Row = {	},
				Count = 1,
			},
			Hand = {
				Row = {	},
				Count = 1,
			},
			Waist = {
				Row = {	},
				Count = 1,
			},
			Leg = {
				Row = {	},
				Count = 1,
			},
			Foot = {
				Row = {	},
				Count = 1,
			},
			Ring = {
				Row = {	},
				Count = 1,
			},
			Trinket = {
				Row = {	},
				Count = 1,
			},
			Main = {
				Row = {	},
				Count = 1,
			},
			Off = {
				Row = {	},
				Count = 1,
			},
			Ranged = {
				Row = {	},
				Count = 1,
			},
			Other = {
				Row = {	},
				Count = 1,
			},
		},
	},
	profile = {
		minimap = {
			hide = false,
		},
	},
}

function UpgradeList:OnInitialize()
	UpgradeListDBVar = LibStub("AceDB-3.0"):New("UpgradeListDB", defaults)
	LibStub("AceConfig-3.0"):RegisterOptionsTable("UpgradeList", options)
	icon:Register("UpgradeList", UpgradeListLDB, UpgradeListDBVar.profile.minimap)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("UpgradeList", "UpgradeList")
	self:RegisterChatCommand("upgradelist", "ChatCommand")
	self:RegisterChatCommand("ul", "ChatCommand")
end

local waitTable = {};
local waitFrame = nil;

function UpgradeList_wait(delay, func, ...)
  if(type(delay)~="number" or type(func)~="function") then
    return false;
  end
  if(waitFrame == nil) then
    waitFrame = CreateFrame("Frame","WaitFrame", UIParent);
    waitFrame:SetScript("onUpdate",function (self,elapse)
      local count = #waitTable;
      local i = 1;
      while(i<=count) do
        local waitRecord = tremove(waitTable,i);
        local d = tremove(waitRecord,1);
        local f = tremove(waitRecord,1);
        local p = tremove(waitRecord,1);
        if(d>elapse) then
          tinsert(waitTable,i,{d-elapse,f,p});
          i = i + 1;
        else
          count = count - 1;
          f(unpack(p));
        end
      end
    end);
  end
  tinsert(waitTable,{delay,func,{...}});
  return true;
end

function UpgradeList:ChatCommand(input)
	if not input or input:trim() == "" then
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
	else
		LibStub("AceConfigCmd-3.0").HandleCommand(UpgradeList, "ul", "upgradelist", input)
	end
end

function UpgradeList:OpenUpgradeList()
	UpgradeListMainFrame:Show()
	InterfaceOptionsFrame:Hide()
	GameMenuButtonContinue:Click()
end

local function LoadHeadItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
	if ViewPrimarySpec:GetChecked() then
		tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Head.Row, true);
	else
		tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Head.Row, true);
	end
end

local function LoadNeckItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
	if ViewPrimarySpec:GetChecked() then
		tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Neck.Row, true);
	else
		tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Neck.Row, true);
	end
end

local function LoadShoulderItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
	if ViewPrimarySpec:GetChecked() then
		tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row, true);
	else
		tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row, true);
	end
end

local function LoadBackItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
	if ViewPrimarySpec:GetChecked() then
		tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Back.Row, true);
	else
		tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Back.Row, true);
	end
end

local function LoadChestItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
	if ViewPrimarySpec:GetChecked() then
		tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Chest.Row, true);
	else
		tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Chest.Row, true);
	end
end

local function LoadWristItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
	if ViewPrimarySpec:GetChecked() then
		tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Wrist.Row, true);
	else
		tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Wrist.Row, true);
	end
end

local function LoadHandItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
	if ViewPrimarySpec:GetChecked() then
		tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Hand.Row, true);
	else
		tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Hand.Row, true);
	end
end

local function LoadWaistItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
	if ViewPrimarySpec:GetChecked() then
		tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Waist.Row, true);
	else
		tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Waist.Row, true);
	end
end

local function LoadLegItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
	if ViewPrimarySpec:GetChecked() then
		tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Leg.Row, true);
	else
		tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Leg.Row, true);
	end
end

local function LoadFootItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
	if ViewPrimarySpec:GetChecked() then
		tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Foot.Row, true);
	else
		tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Foot.Row, true);
	end
end

local function LoadRingItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
	if ViewPrimarySpec:GetChecked() then
		tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Ring.Row, true);
	else
		tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Ring.Row, true);
	end
end

local function LoadTrinketItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
	if ViewPrimarySpec:GetChecked() then
		tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Trinket.Row, true);
	else
		tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Trinket.Row, true);
	end
end

local function LoadMainItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
	if ViewPrimarySpec:GetChecked() then
		tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Main.Row, true);
	else
		tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Main.Row, true);
	end
end

local function LoadOffItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
	if ViewPrimarySpec:GetChecked() then
		tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Off.Row, true);
	else
		tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Off.Row, true);
	end
end

local function LoadRangedItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
	if ViewPrimarySpec:GetChecked() then
		tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Ranged.Row, true);
	else
		tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Ranged.Row, true);
	end
end

local function LoadOtherItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
	if ViewPrimarySpec:GetChecked() then
		tableUL:SetData(UpgradeListDBVar.char.PrimarySpecList.Other.Row, true);
	else
		tableUL:SetData(UpgradeListDBVar.char.SecondarySpecList.Other.Row, true);
	end
end

local function EnterItemIntoDatabase(ItemEntryBox, tableUL, PrimarySpecRadioButton, SecondarySpecRadioButton, ViewPrimarySpec, ViewSecondarySpec, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice)
	local priorityfieldnum = tonumber(priorityfield:GetText());
	if priorityfieldnum ~= nil then
		priorityfieldnum = math.floor(priorityfieldnum);
	end
	if itemEquipLoc == "INVTYPE_HEAD" then --Head Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UPGRADELIST_SELECTEDINSTANCE == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Head.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Head.Row[UpgradeListDBVar.char.PrimarySpecList.Head.Count] = { UpgradeListDBVar.char.PrimarySpecList.Head.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Head.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Head.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
				for i = UpgradeListDBVar.char.PrimarySpecList.Head.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Head.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Head.Count = UpgradeListDBVar.char.PrimarySpecList.Head.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Head tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 1) and (ViewPrimarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
				LoadHeadItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
			UPGRADELIST_SELECTEDINSTANCE = nil;
			UPGRADELIST_SELECTEDBOSS = nil;
			UPGRADELIST_SELECTEDDIFFICULTY = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Head.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Head.Row[UpgradeListDBVar.char.SecondarySpecList.Head.Count] = { UpgradeListDBVar.char.SecondarySpecList.Head.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Head.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Head.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
				for i = UpgradeListDBVar.char.SecondarySpecList.Head.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Head.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Head.Count = UpgradeListDBVar.char.SecondarySpecList.Head.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Head tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 1) and (ViewSecondarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
				LoadHeadItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
			UPGRADELIST_SELECTEDINSTANCE = nil;
			UPGRADELIST_SELECTEDBOSS = nil;
			UPGRADELIST_SELECTEDDIFFICULTY = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_NECK" then --Neck Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UPGRADELIST_SELECTEDINSTANCE == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Neck.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Neck.Row[UpgradeListDBVar.char.PrimarySpecList.Neck.Count] = { UpgradeListDBVar.char.PrimarySpecList.Neck.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Neck.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Neck.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
				for i = UpgradeListDBVar.char.PrimarySpecList.Neck.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Neck.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Neck.Count = UpgradeListDBVar.char.PrimarySpecList.Neck.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Neck tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 2) and (ViewPrimarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
				LoadNeckItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
			UPGRADELIST_SELECTEDINSTANCE = nil;
			UPGRADELIST_SELECTEDBOSS = nil;
			UPGRADELIST_SELECTEDDIFFICULTY = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Neck.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Neck.Row[UpgradeListDBVar.char.SecondarySpecList.Neck.Count] = { UpgradeListDBVar.char.SecondarySpecList.Neck.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Neck.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Neck.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
				for i = UpgradeListDBVar.char.SecondarySpecList.Neck.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Neck.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Neck.Count = UpgradeListDBVar.char.SecondarySpecList.Neck.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Neck tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 2) and (ViewSecondarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
				LoadNeckItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
			UPGRADELIST_SELECTEDINSTANCE = nil;
			UPGRADELIST_SELECTEDBOSS = nil;
			UPGRADELIST_SELECTEDDIFFICULTY = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_SHOULDER" then --Shoulder Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UPGRADELIST_SELECTEDINSTANCE == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count] = { UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
				for i = UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count = UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Shoulder tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 3) and (ViewPrimarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
				LoadShoulderItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
			UPGRADELIST_SELECTEDINSTANCE = nil;
			UPGRADELIST_SELECTEDBOSS = nil;
			UPGRADELIST_SELECTEDDIFFICULTY = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count] = { UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
				for i = UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count = UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Shoulder tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 3) and (ViewSecondarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
				LoadShoulderItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
			UPGRADELIST_SELECTEDINSTANCE = nil;
			UPGRADELIST_SELECTEDBOSS = nil;
			UPGRADELIST_SELECTEDDIFFICULTY = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_CLOAK" then --Back Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UPGRADELIST_SELECTEDINSTANCE == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Back.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Back.Row[UpgradeListDBVar.char.PrimarySpecList.Back.Count] = { UpgradeListDBVar.char.PrimarySpecList.Back.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Back.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Back.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
				for i = UpgradeListDBVar.char.PrimarySpecList.Back.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Back.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Back.Count = UpgradeListDBVar.char.PrimarySpecList.Back.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Back tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 4) and (ViewPrimarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
				LoadBackItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
			UPGRADELIST_SELECTEDINSTANCE = nil;
			UPGRADELIST_SELECTEDBOSS = nil;
			UPGRADELIST_SELECTEDDIFFICULTY = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Back.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Back.Row[UpgradeListDBVar.char.SecondarySpecList.Back.Count] = { UpgradeListDBVar.char.SecondarySpecList.Back.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Back.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Back.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
				for i = UpgradeListDBVar.char.SecondarySpecList.Back.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Back.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Back.Count = UpgradeListDBVar.char.SecondarySpecList.Back.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Back tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 4) and (ViewSecondarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
				LoadBackItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
			UPGRADELIST_SELECTEDINSTANCE = nil;
			UPGRADELIST_SELECTEDBOSS = nil;
			UPGRADELIST_SELECTEDDIFFICULTY = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_CHEST" or itemEquipLoc == "INVTYPE_ROBE" then --Chest Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UPGRADELIST_SELECTEDINSTANCE == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Chest.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Chest.Row[UpgradeListDBVar.char.PrimarySpecList.Chest.Count] = { UpgradeListDBVar.char.PrimarySpecList.Chest.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Chest.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Chest.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
				for i = UpgradeListDBVar.char.PrimarySpecList.Chest.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Chest.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Chest.Count = UpgradeListDBVar.char.PrimarySpecList.Chest.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Chest tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 5) and (ViewPrimarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
				LoadChestItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
			UPGRADELIST_SELECTEDINSTANCE = nil;
			UPGRADELIST_SELECTEDBOSS = nil;
			UPGRADELIST_SELECTEDDIFFICULTY = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Chest.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Chest.Row[UpgradeListDBVar.char.SecondarySpecList.Chest.Count] = { UpgradeListDBVar.char.SecondarySpecList.Chest.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Chest.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Chest.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
				for i = UpgradeListDBVar.char.SecondarySpecList.Chest.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Chest.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Chest.Count = UpgradeListDBVar.char.SecondarySpecList.Chest.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Chest tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 5) and (ViewSecondarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
				LoadChestItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
			UPGRADELIST_SELECTEDINSTANCE = nil;
			UPGRADELIST_SELECTEDBOSS = nil;
			UPGRADELIST_SELECTEDDIFFICULTY = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_WRIST" then --Wrist Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UPGRADELIST_SELECTEDINSTANCE == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Wrist.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[UpgradeListDBVar.char.PrimarySpecList.Wrist.Count] = { UpgradeListDBVar.char.PrimarySpecList.Wrist.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Wrist.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Wrist.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
				for i = UpgradeListDBVar.char.PrimarySpecList.Wrist.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Wrist.Count = UpgradeListDBVar.char.PrimarySpecList.Wrist.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Wrist tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 6) and (ViewPrimarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
				LoadWristItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
			UPGRADELIST_SELECTEDINSTANCE = nil;
			UPGRADELIST_SELECTEDBOSS = nil;
			UPGRADELIST_SELECTEDDIFFICULTY = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Wrist.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[UpgradeListDBVar.char.SecondarySpecList.Wrist.Count] = { UpgradeListDBVar.char.SecondarySpecList.Wrist.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Wrist.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Wrist.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
				for i = UpgradeListDBVar.char.SecondarySpecList.Wrist.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Wrist.Count = UpgradeListDBVar.char.SecondarySpecList.Wrist.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Wrist tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 6) and (ViewSecondarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
				LoadWristItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
			UPGRADELIST_SELECTEDINSTANCE = nil;
			UPGRADELIST_SELECTEDBOSS = nil;
			UPGRADELIST_SELECTEDDIFFICULTY = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_HAND" then --Hand Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UPGRADELIST_SELECTEDINSTANCE == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Hand.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Hand.Row[UpgradeListDBVar.char.PrimarySpecList.Hand.Count] = { UpgradeListDBVar.char.PrimarySpecList.Hand.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Hand.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Hand.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
				for i = UpgradeListDBVar.char.PrimarySpecList.Hand.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Hand.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Hand.Count = UpgradeListDBVar.char.PrimarySpecList.Hand.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Hand tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 7) and (ViewPrimarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
				LoadHandItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
			UPGRADELIST_SELECTEDINSTANCE = nil;
			UPGRADELIST_SELECTEDBOSS = nil;
			UPGRADELIST_SELECTEDDIFFICULTY = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Hand.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Hand.Row[UpgradeListDBVar.char.SecondarySpecList.Hand.Count] = { UpgradeListDBVar.char.SecondarySpecList.Hand.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Hand.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Hand.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
				for i = UpgradeListDBVar.char.SecondarySpecList.Hand.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Hand.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Hand.Count = UpgradeListDBVar.char.SecondarySpecList.Hand.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Hand tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 7) and (ViewSecondarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
				LoadHandItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
			UPGRADELIST_SELECTEDINSTANCE = nil;
			UPGRADELIST_SELECTEDBOSS = nil;
			UPGRADELIST_SELECTEDDIFFICULTY = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_WAIST" then --Waist Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UPGRADELIST_SELECTEDINSTANCE == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Waist.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Waist.Row[UpgradeListDBVar.char.PrimarySpecList.Waist.Count] = { UpgradeListDBVar.char.PrimarySpecList.Waist.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Waist.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Waist.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
				for i = UpgradeListDBVar.char.PrimarySpecList.Waist.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Waist.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Waist.Count = UpgradeListDBVar.char.PrimarySpecList.Waist.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Waist tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 8) and (ViewPrimarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
				LoadWaistItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
			UPGRADELIST_SELECTEDINSTANCE = nil;
			UPGRADELIST_SELECTEDBOSS = nil;
			UPGRADELIST_SELECTEDDIFFICULTY = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Waist.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Waist.Row[UpgradeListDBVar.char.SecondarySpecList.Waist.Count] = { UpgradeListDBVar.char.SecondarySpecList.Waist.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Waist.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Waist.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
				for i = UpgradeListDBVar.char.SecondarySpecList.Waist.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Waist.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Waist.Count = UpgradeListDBVar.char.SecondarySpecList.Waist.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Waist tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 8) and (ViewSecondarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
				LoadWaistItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
			UPGRADELIST_SELECTEDINSTANCE = nil;
			UPGRADELIST_SELECTEDBOSS = nil;
			UPGRADELIST_SELECTEDDIFFICULTY = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_LEGS" then --Leg Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UPGRADELIST_SELECTEDINSTANCE == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Leg.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Leg.Row[UpgradeListDBVar.char.PrimarySpecList.Leg.Count] = { UpgradeListDBVar.char.PrimarySpecList.Leg.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Leg.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Leg.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
				for i = UpgradeListDBVar.char.PrimarySpecList.Leg.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Leg.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Leg.Count = UpgradeListDBVar.char.PrimarySpecList.Leg.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Leg tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 9) and (ViewPrimarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
				LoadLegItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
			UPGRADELIST_SELECTEDINSTANCE = nil;
			UPGRADELIST_SELECTEDBOSS = nil;
			UPGRADELIST_SELECTEDDIFFICULTY = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Leg.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Leg.Row[UpgradeListDBVar.char.SecondarySpecList.Leg.Count] = { UpgradeListDBVar.char.SecondarySpecList.Leg.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Leg.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Leg.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
				for i = UpgradeListDBVar.char.SecondarySpecList.Leg.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Leg.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Leg.Count = UpgradeListDBVar.char.SecondarySpecList.Leg.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Leg tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 9) and (ViewSecondarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
				LoadLegItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
			UPGRADELIST_SELECTEDINSTANCE = nil;
			UPGRADELIST_SELECTEDBOSS = nil;
			UPGRADELIST_SELECTEDDIFFICULTY = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_FEET" then --Foot Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UPGRADELIST_SELECTEDINSTANCE == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Foot.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Foot.Row[UpgradeListDBVar.char.PrimarySpecList.Foot.Count] = { UpgradeListDBVar.char.PrimarySpecList.Foot.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Foot.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Foot.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
				for i = UpgradeListDBVar.char.PrimarySpecList.Foot.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Foot.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Foot.Count = UpgradeListDBVar.char.PrimarySpecList.Foot.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Foot tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 10) and (ViewPrimarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
				LoadFootItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
			UPGRADELIST_SELECTEDINSTANCE = nil;
			UPGRADELIST_SELECTEDBOSS = nil;
			UPGRADELIST_SELECTEDDIFFICULTY = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Foot.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Foot.Row[UpgradeListDBVar.char.SecondarySpecList.Foot.Count] = { UpgradeListDBVar.char.SecondarySpecList.Foot.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Foot.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Foot.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
				for i = UpgradeListDBVar.char.SecondarySpecList.Foot.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Foot.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Foot.Count = UpgradeListDBVar.char.SecondarySpecList.Foot.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Foot tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 10) and (ViewSecondarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
				LoadFootItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
			UPGRADELIST_SELECTEDINSTANCE = nil;
			UPGRADELIST_SELECTEDBOSS = nil;
			UPGRADELIST_SELECTEDDIFFICULTY = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_FINGER" then --Rings
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UPGRADELIST_SELECTEDINSTANCE == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Ring.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Ring.Row[UpgradeListDBVar.char.PrimarySpecList.Ring.Count] = { UpgradeListDBVar.char.PrimarySpecList.Ring.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Ring.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Ring.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
				for i = UpgradeListDBVar.char.PrimarySpecList.Ring.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Ring.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Ring.Count = UpgradeListDBVar.char.PrimarySpecList.Ring.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Ring tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 11) and (ViewPrimarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
				LoadRingItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
			UPGRADELIST_SELECTEDINSTANCE = nil;
			UPGRADELIST_SELECTEDBOSS = nil;
			UPGRADELIST_SELECTEDDIFFICULTY = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Ring.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Ring.Row[UpgradeListDBVar.char.SecondarySpecList.Ring.Count] = { UpgradeListDBVar.char.SecondarySpecList.Ring.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Ring.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Ring.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
				for i = UpgradeListDBVar.char.SecondarySpecList.Ring.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Ring.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Ring.Count = UpgradeListDBVar.char.SecondarySpecList.Ring.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Ring tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 11) and (ViewSecondarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
				LoadRingItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
			UPGRADELIST_SELECTEDINSTANCE = nil;
			UPGRADELIST_SELECTEDBOSS = nil;
			UPGRADELIST_SELECTEDDIFFICULTY = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_TRINKET" then --Trinkets
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UPGRADELIST_SELECTEDINSTANCE == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Trinket.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[UpgradeListDBVar.char.PrimarySpecList.Trinket.Count] = { UpgradeListDBVar.char.PrimarySpecList.Trinket.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Trinket.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Trinket.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
				for i = UpgradeListDBVar.char.PrimarySpecList.Trinket.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Trinket.Count = UpgradeListDBVar.char.PrimarySpecList.Trinket.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Trinket tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 12) and (ViewPrimarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
				LoadTrinketItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
			UPGRADELIST_SELECTEDINSTANCE = nil;
			UPGRADELIST_SELECTEDBOSS = nil;
			UPGRADELIST_SELECTEDDIFFICULTY = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Trinket.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[UpgradeListDBVar.char.SecondarySpecList.Trinket.Count] = { UpgradeListDBVar.char.SecondarySpecList.Trinket.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Trinket.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Trinket.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
				for i = UpgradeListDBVar.char.SecondarySpecList.Trinket.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Trinket.Count = UpgradeListDBVar.char.SecondarySpecList.Trinket.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Trinket tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 12) and (ViewSecondarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
				LoadTrinketItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
			UPGRADELIST_SELECTEDINSTANCE = nil;
			UPGRADELIST_SELECTEDBOSS = nil;
			UPGRADELIST_SELECTEDDIFFICULTY = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_WEAPONMAINHAND" or itemEquipLoc == "INVTYPE_2HWEAPON" then --Main Hand Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UPGRADELIST_SELECTEDINSTANCE == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Main.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Main.Row[UpgradeListDBVar.char.PrimarySpecList.Main.Count] = { UpgradeListDBVar.char.PrimarySpecList.Main.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Main.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Main.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
				for i = UpgradeListDBVar.char.PrimarySpecList.Main.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Main.Count = UpgradeListDBVar.char.PrimarySpecList.Main.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Main tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 13) and (ViewPrimarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
				LoadMainItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
			UPGRADELIST_SELECTEDINSTANCE = nil;
			UPGRADELIST_SELECTEDBOSS = nil;
			UPGRADELIST_SELECTEDDIFFICULTY = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Main.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Main.Row[UpgradeListDBVar.char.SecondarySpecList.Main.Count] = { UpgradeListDBVar.char.SecondarySpecList.Main.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Main.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Main.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
				for i = UpgradeListDBVar.char.SecondarySpecList.Main.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Main.Count = UpgradeListDBVar.char.SecondarySpecList.Main.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Main tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 13) and (ViewSecondarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
				LoadMainItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
			UPGRADELIST_SELECTEDINSTANCE = nil;
			UPGRADELIST_SELECTEDBOSS = nil;
			UPGRADELIST_SELECTEDDIFFICULTY = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_WEAPONOFFHAND" or itemEquipLoc == "INVTYPE_SHIELD" or itemEquipLoc == "INVTYPE_HOLDABLE" then --Off Hand Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UPGRADELIST_SELECTEDINSTANCE == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Off.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Off.Row[UpgradeListDBVar.char.PrimarySpecList.Off.Count] = { UpgradeListDBVar.char.PrimarySpecList.Off.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Off.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Off.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
				for i = UpgradeListDBVar.char.PrimarySpecList.Off.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Off.Count = UpgradeListDBVar.char.PrimarySpecList.Off.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Off tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 14) and (ViewPrimarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
				LoadOffItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
			UPGRADELIST_SELECTEDINSTANCE = nil;
			UPGRADELIST_SELECTEDBOSS = nil;
			UPGRADELIST_SELECTEDDIFFICULTY = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Off.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Off.Row[UpgradeListDBVar.char.SecondarySpecList.Off.Count] = { UpgradeListDBVar.char.SecondarySpecList.Off.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Off.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Off.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
				for i = UpgradeListDBVar.char.SecondarySpecList.Off.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Off.Count = UpgradeListDBVar.char.SecondarySpecList.Off.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Off tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 14) and (ViewSecondarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
				LoadOffItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
			UPGRADELIST_SELECTEDINSTANCE = nil;
			UPGRADELIST_SELECTEDBOSS = nil;
			UPGRADELIST_SELECTEDDIFFICULTY = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_RANGED" or itemEquipLoc == "INVTYPE_THROWN" or itemEquipLoc == "INVTYPE_RANGEDRIGHT" or itemEquipLoc == "INVTYPE_RELIC" then --Ranged Slot Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UPGRADELIST_SELECTEDINSTANCE == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Ranged.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[UpgradeListDBVar.char.PrimarySpecList.Ranged.Count] = { UpgradeListDBVar.char.PrimarySpecList.Ranged.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Ranged.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Ranged.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
				for i = UpgradeListDBVar.char.PrimarySpecList.Ranged.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Ranged.Count = UpgradeListDBVar.char.PrimarySpecList.Ranged.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Ranged tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 15) and (ViewPrimarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
				LoadRangedItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
			UPGRADELIST_SELECTEDINSTANCE = nil;
			UPGRADELIST_SELECTEDBOSS = nil;
			UPGRADELIST_SELECTEDDIFFICULTY = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Ranged.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[UpgradeListDBVar.char.SecondarySpecList.Ranged.Count] = { UpgradeListDBVar.char.SecondarySpecList.Ranged.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Ranged.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Ranged.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
				for i = UpgradeListDBVar.char.SecondarySpecList.Ranged.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Ranged.Count = UpgradeListDBVar.char.SecondarySpecList.Ranged.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Ranged tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 15) and (ViewSecondarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
				LoadRangedItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
			UPGRADELIST_SELECTEDINSTANCE = nil;
			UPGRADELIST_SELECTEDBOSS = nil;
			UPGRADELIST_SELECTEDDIFFICULTY = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	elseif itemEquipLoc == "INVTYPE_WEAPON" then --Main Hand OR Off Hand Item
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UPGRADELIST_SELECTEDINSTANCE == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		else
			WeaponInput:Show(); --After checking that priority field is a number and an item location is selected, show the WeaponInput frame.
			UpgradeListMainFrame:EnableMouse(false)
			CloseButton:EnableMouse(false)
			ToggleButton:EnableMouse(false)
			ViewPrimarySpec:EnableMouse(false)
			ViewSecondarySpec:EnableMouse(false)
			OptionsFrame:EnableMouse(false)
			ItemEntryBox:EnableMouse(false)
			DropDown_Button:EnableMouse(false)
			NoteEntryBox:EnableMouse(false)
			PrimarySpecRadioButton:EnableMouse(false)
			SecondarySpecRadioButton:EnableMouse(false)
			priorityfield:EnableMouse(false)
			AddButton:EnableMouse(false)
			tofield:EnableMouse(false)
			fromfield:EnableMouse(false)
			MoveButton:EnableMouse(false)
			DeleteButton:EnableMouse(false)
			deletefield:EnableMouse(false)
		end
	else --Adding to Other tab.
		if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Priority field must be a number.");
			priorityfield:HighlightText();
		elseif UPGRADELIST_SELECTEDINSTANCE == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("You must select an item location.");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:ClearFocus();
			priorityfield:ClearFocus();
		elseif PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Other.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.PrimarySpecList.Other.Row[UpgradeListDBVar.char.PrimarySpecList.Other.Count] = { UpgradeListDBVar.char.PrimarySpecList.Other.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
			elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Other.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.PrimarySpecList.Other.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
				for i = UpgradeListDBVar.char.PrimarySpecList.Other.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.PrimarySpecList.Other.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.PrimarySpecList.Other.Count = UpgradeListDBVar.char.PrimarySpecList.Other.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Other tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 12) and (ViewPrimarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
				LoadOtherItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
			UPGRADELIST_SELECTEDINSTANCE = nil;
			UPGRADELIST_SELECTEDBOSS = nil;
			UPGRADELIST_SELECTEDDIFFICULTY = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		else --Adding to Secondary Spec List
			if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Other.Count then --Priority # entered was blank or bigger than the list of items
				UpgradeListDBVar.char.SecondarySpecList.Other.Row[UpgradeListDBVar.char.SecondarySpecList.Other.Count] = { UpgradeListDBVar.char.SecondarySpecList.Other.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
			elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Other.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
				table.insert(UpgradeListDBVar.char.SecondarySpecList.Other.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
				for i = UpgradeListDBVar.char.SecondarySpecList.Other.Count, priorityfieldnum, -1 do
					UpgradeListDBVar.char.SecondarySpecList.Other.Row[i][1] = i;
				end
			end
			UpgradeListDBVar.char.SecondarySpecList.Other.Count = UpgradeListDBVar.char.SecondarySpecList.Other.Count + 1;
			statusbarfont:SetTextColor(0, 1, 0);
			statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Other tab.");
			if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 12) and (ViewSecondarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
				LoadOtherItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
			UPGRADELIST_SELECTEDINSTANCE = nil;
			UPGRADELIST_SELECTEDBOSS = nil;
			UPGRADELIST_SELECTEDDIFFICULTY = nil;
			ItemEntryBox:SetText("");
			ItemEntryBox:ClearFocus();
			NoteEntryBox:SetText("");
			NoteEntryBox:ClearFocus();
			priorityfield:SetText("");
			priorityfield:ClearFocus();
			UIDropDownMenu_SetText(DropDown_Button, "Location:");
		end
	end
end

local function AddItem(ItemEntryBox, tableUL, PrimarySpecRadioButton, SecondarySpecRadioButton, ViewPrimarySpec, ViewSecondarySpec, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox)
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(ItemEntryBox:GetText());
	--print ("Equip Loc: " .. itemEquipLoc);
	--print ("Sub Type: " .. itemSubType);
	if itemEquipLoc ~= nil and itemSubType == "Junk" then --Tokens
		EnterItemIntoDatabase(ItemEntryBox, tableUL, PrimarySpecRadioButton, SecondarySpecRadioButton, ViewPrimarySpec, ViewSecondarySpec, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice)
	elseif itemEquipLoc == nil then
		statusbarfont:SetTextColor(1, 0, 0);
		statusbarfont:SetText("Invalid item.");
		ItemEntryBox:HighlightText();
	else
		local localizedClass, englishClass = UnitClass("player");
		if englishClass == "DEATHKNIGHT" then
			if (itemSubType ~= "Cloth") and (itemSubType ~= "Leather") and (itemSubType ~= "Mail") and (itemSubType ~= "Plate") and (itemSubType ~= "Relic") and (itemSubType ~= "One-Handed Maces") and (itemSubType ~= "Two-Handed Maces") and (itemSubType ~= "Polearms") and (itemSubType ~= "One-Handed Swords") and (itemSubType ~= "Two-Handed Swords") and (itemSubType ~= "One-Handed Axes") and (itemSubType ~= "Two-Handed Axes") then
				--The player CANNOT equip the item.
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Your character cannot equip " .. itemLink);
				ItemEntryBox:HighlightText();
			else
				--The player CAN equip the item.
				EnterItemIntoDatabase(ItemEntryBox, tableUL, PrimarySpecRadioButton, SecondarySpecRadioButton, ViewPrimarySpec, ViewSecondarySpec, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice)
			end
		elseif englishClass == "DRUID" then
			if (itemSubType ~= "Cloth") and (itemSubType ~= "Leather") and (itemSubType ~= "Relic") and (itemSubType ~= "Daggers") and (itemSubType ~= "Fist Weapons") and (itemSubType ~= "One-Handed Maces") and (itemSubType ~= "Polearms") and (itemSubType ~= "Staves") and (itemSubType ~= "Two-Handed Maces") and (itemSubType ~= "Miscellaneous") then
				--The player CANNOT equip the item.
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Your character cannot equip " .. itemLink);
				ItemEntryBox:HighlightText();
			else
				--The player CAN equip the item.
				EnterItemIntoDatabase(ItemEntryBox, tableUL, PrimarySpecRadioButton, SecondarySpecRadioButton, ViewPrimarySpec, ViewSecondarySpec, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice)
			end
		elseif englishClass == "HUNTER" then
			if (itemSubType ~= "Cloth") and (itemSubType ~= "Leather") and (itemSubType ~= "Mail") and (itemSubType ~= "Guns") and (itemSubType ~= "Bows") and (itemSubType ~= "Crossbows") and (itemSubType ~= "Thrown") and (itemSubType ~= "Fist Weapons") and (itemSubType ~= "One-Handed Axes") and (itemSubType ~= "One-Handed Swords") and (itemSubType ~= "Polearms") and (itemSubType ~= "Staves") and (itemSubType ~= "Two-Handed Axes") and (itemSubType ~= "Two-Handed Swords") then
				--The player CANNOT equip the item.
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Your character cannot equip " .. itemLink);
				ItemEntryBox:HighlightText();
			else
				--The player CAN equip the item.
				EnterItemIntoDatabase(ItemEntryBox, tableUL, PrimarySpecRadioButton, SecondarySpecRadioButton, ViewPrimarySpec, ViewSecondarySpec, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice)
			end
		elseif englishClass == "MAGE" then
			if (itemSubType ~= "Cloth") and (itemSubType ~= "Staves") and (itemSubType ~= "Wands") and (itemSubType ~= "Daggers") and (itemSubType ~= "One-Handed Swords") and (itemSubType ~= "Miscellaneous") then
				--The player CANNOT equip the item.
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Your character cannot equip " .. itemLink);
				ItemEntryBox:HighlightText();
			else
				--The player CAN equip the item.
				EnterItemIntoDatabase(ItemEntryBox, tableUL, PrimarySpecRadioButton, SecondarySpecRadioButton, ViewPrimarySpec, ViewSecondarySpec, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice)
			end
		elseif englishClass == "PALADIN" then
			if (itemSubType ~= "Cloth") and (itemSubType ~= "Leather") and (itemSubType ~= "Mail") and (itemSubType ~= "Plate") and (itemSubType ~= "Shields") and (itemSubType ~= "Relic") and (itemSubType ~= "One-Handed Maces") and (itemSubType ~= "Two-Handed Maces") and (itemSubType ~= "Polearms") and (itemSubType ~= "One-Handed Swords") and (itemSubType ~= "Two-Handed Swords") and (itemSubType ~= "One-Handed Axes") and (itemSubType ~= "Two-Handed Axes") then
				--The player CANNOT equip the item.
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Your character cannot equip " .. itemLink);
				ItemEntryBox:HighlightText();
			else
				--The player CAN equip the item.
				EnterItemIntoDatabase(ItemEntryBox, tableUL, PrimarySpecRadioButton, SecondarySpecRadioButton, ViewPrimarySpec, ViewSecondarySpec, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice)
			end
		elseif englishClass == "PRIEST" then
			if (itemSubType ~= "Cloth") and (itemSubType ~= "Staves") and (itemSubType ~= "Wands") and (itemSubType ~= "Daggers") and (itemSubType ~= "One-Handed Maces") and (itemSubType ~= "Miscellaneous") then
				--The player CANNOT equip the item.
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Your character cannot equip " .. itemLink);
				ItemEntryBox:HighlightText();
			else
				--The player CAN equip the item.
				EnterItemIntoDatabase(ItemEntryBox, tableUL, PrimarySpecRadioButton, SecondarySpecRadioButton, ViewPrimarySpec, ViewSecondarySpec, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice)
			end
		elseif englishClass == "ROGUE" then
			if (itemSubType ~= "Cloth") and (itemSubType ~= "Leather") and (itemSubType ~= "Daggers") and (itemSubType ~= "Fist Weapons") and (itemSubType ~= "One-Handed Maces") and (itemSubType ~= "One-Handed Axes") and (itemSubType ~= "One-Handed Swords") and (itemSubType ~= "Bows") and (itemSubType ~= "Crossbows") and (itemSubType ~= "Thrown") and (itemSubType ~= "Guns") then
				--The player CANNOT equip the item.
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Your character cannot equip " .. itemLink);
				ItemEntryBox:HighlightText();
			else
				--The player CAN equip the item.
				EnterItemIntoDatabase(ItemEntryBox, tableUL, PrimarySpecRadioButton, SecondarySpecRadioButton, ViewPrimarySpec, ViewSecondarySpec, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice)
			end
		elseif englishClass == "SHAMAN" then
			if (itemSubType ~= "Cloth") and (itemSubType ~= "Leather") and (itemSubType ~= "Mail") and (itemSubType ~= "Shields") and (itemSubType ~= "Daggers") and (itemSubType ~= "Fist Weapons") and (itemSubType ~= "One-Handed Maces") and (itemSubType ~= "One-Handed Axes") and (itemSubType ~= "Relic") and (itemSubType ~= "Staves") and (itemSubType ~= "Two-Handed Maces") and (itemSubType ~= "Two-Handed Axes") then
				--The player CANNOT equip the item.
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Your character cannot equip " .. itemLink);
				ItemEntryBox:HighlightText();
			else
				--The player CAN equip the item.
				EnterItemIntoDatabase(ItemEntryBox, tableUL, PrimarySpecRadioButton, SecondarySpecRadioButton, ViewPrimarySpec, ViewSecondarySpec, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice)
			end
		elseif englishClass == "WARLOCK" then
			if (itemSubType ~= "Cloth") and (itemSubType ~= "Staves") and (itemSubType ~= "Wands") and (itemSubType ~= "Daggers") and (itemSubType ~= "One-Handed Swords") and (itemSubType ~= "Miscellaneous") then
				--The player CANNOT equip the item.
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Your character cannot equip " .. itemLink);
				ItemEntryBox:HighlightText();
			else
				--The player CAN equip the item.
				EnterItemIntoDatabase(ItemEntryBox, tableUL, PrimarySpecRadioButton, SecondarySpecRadioButton, ViewPrimarySpec, ViewSecondarySpec, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice)
			end
		elseif englishClass == "WARRIOR" then
			if (itemSubType ~= "Cloth") and (itemSubType ~= "Leather") and (itemSubType ~= "Mail") and (itemSubType ~= "Plate") and (itemSubType ~= "Shields") and (itemSubType ~= "Bows") and (itemSubType ~= "Crossbows") and (itemSubType ~= "Fist Weapons") and (itemSubType ~= "Guns") and (itemSubType ~= "One-Handed Axes") and (itemSubType ~= "One-Handed Maces") and (itemSubType ~= "One-Handed Swords") and (itemSubType ~= "Polearms") and (itemSubType ~= "Staves") and (itemSubType ~= "Two-Handed Axes") and (itemSubType ~= "Two-Handed Maces") and (itemSubType ~= "Two-Handed Swords") and (itemSubType ~= "Miscellaneous") then
				--The player CANNOT equip the equipable item
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Your character cannot equip " .. itemLink);
				ItemEntryBox:HighlightText();
			else 
				--Player can equip the item
				EnterItemIntoDatabase(ItemEntryBox, tableUL, PrimarySpecRadioButton, SecondarySpecRadioButton, ViewPrimarySpec, ViewSecondarySpec, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox, itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice)
			end
		else
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("ERROR: Unable to determine your class.");
		end
	end
end

local function DeleteItem(deletefield, UpgradeListMainFrame, ViewPrimarySpec, ViewSecondarySpec, statusbarfont, tableUL)
	local deletefieldnum = tonumber(deletefield:GetText());
	if deletefieldnum ~= nil then
		deletefieldnum = math.floor(deletefieldnum);
	end
	if deletefieldnum == nil and deletefield:GetText() ~= "" then
		statusbarfont:SetTextColor(1, 0, 0);
		statusbarfont:SetText("Delete field must be a number.");
		deletefield:HighlightText();
	elseif deletefieldnum == nil then
		statusbarfont:SetTextColor(1, 0, 0);
		statusbarfont:SetText("Nothing entered in delete field.");
		deletefield:HighlightText();
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 1 then --If the head tab is selected
		if ViewPrimarySpec:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Head.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Head list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Head.Count - 1 and deletefieldnum > 0 then --If deleted item is NOT the last one in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Head.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Head.Count = UpgradeListDBVar.char.PrimarySpecList.Head.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Head list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Head.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Head.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Head.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadHeadItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			elseif deletefieldnum > 0 then --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Head.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Head.Count = UpgradeListDBVar.char.PrimarySpecList.Head.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Head list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadHeadItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			else
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText(deletefieldnum .. " is not a valid number for deletion.");
				deletefield:HighlightText();
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Head.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Head list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Head.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Head.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Head.Count = UpgradeListDBVar.char.SecondarySpecList.Head.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Head list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Head.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Head.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Head.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadHeadItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Head.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Head.Count = UpgradeListDBVar.char.SecondarySpecList.Head.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Head list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadHeadItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 2 then --If the neck tab is selected
		if ViewPrimarySpec:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Neck.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Neck list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Neck.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Neck.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Neck.Count = UpgradeListDBVar.char.PrimarySpecList.Neck.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Neck list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Neck.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Neck.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Neck.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadNeckItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Neck.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Neck.Count = UpgradeListDBVar.char.PrimarySpecList.Neck.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Neck list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadNeckItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Neck.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Neck list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Neck.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Neck.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Neck.Count = UpgradeListDBVar.char.SecondarySpecList.Neck.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Neck list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Neck.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Neck.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Neck.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadNeckItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Neck.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Neck.Count = UpgradeListDBVar.char.SecondarySpecList.Neck.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Neck list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadNeckItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 3 then --If the Shoulder tab is selected
		if ViewPrimarySpec:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Shoulder list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count = UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Shoulder list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadShoulderItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count = UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Shoulder list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadShoulderItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Shoulder list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count = UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Shoulder list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadShoulderItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count = UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Shoulder list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadShoulderItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 4 then --If the Back tab is selected
		if ViewPrimarySpec:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Back.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Back list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Back.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Back.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Back.Count = UpgradeListDBVar.char.PrimarySpecList.Back.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Back list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Back.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Back.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Back.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadBackItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Back.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Back.Count = UpgradeListDBVar.char.PrimarySpecList.Back.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Back list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadBackItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Back.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Back list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Back.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Back.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Back.Count = UpgradeListDBVar.char.SecondarySpecList.Back.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Back list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Back.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Back.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Back.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadBackItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Back.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Back.Count = UpgradeListDBVar.char.SecondarySpecList.Back.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Back list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadBackItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 5 then --If the Chest tab is selected
		if ViewPrimarySpec:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Chest.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Chest list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Chest.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Chest.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Chest.Count = UpgradeListDBVar.char.PrimarySpecList.Chest.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Chest list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Chest.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Chest.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Chest.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadChestItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Chest.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Chest.Count = UpgradeListDBVar.char.PrimarySpecList.Chest.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Chest list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadChestItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Chest.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Chest list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Chest.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Chest.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Chest.Count = UpgradeListDBVar.char.SecondarySpecList.Chest.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Chest list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Chest.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Chest.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Chest.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadChestItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Chest.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Chest.Count = UpgradeListDBVar.char.SecondarySpecList.Chest.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Chest list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadChestItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 6 then --If the Wrist tab is selected
		if ViewPrimarySpec:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Wrist.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Wrist list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Wrist.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Wrist.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Wrist.Count = UpgradeListDBVar.char.PrimarySpecList.Wrist.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Wrist list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Wrist.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadWristItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Wrist.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Wrist.Count = UpgradeListDBVar.char.PrimarySpecList.Wrist.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Wrist list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadWristItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Wrist.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Wrist list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Wrist.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Wrist.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Wrist.Count = UpgradeListDBVar.char.SecondarySpecList.Wrist.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Wrist list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Wrist.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadWristItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Wrist.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Wrist.Count = UpgradeListDBVar.char.SecondarySpecList.Wrist.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Wrist list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadWristItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 7 then --If the Hand tab is selected
		if ViewPrimarySpec:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Hand.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Hand list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Hand.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Hand.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Hand.Count = UpgradeListDBVar.char.PrimarySpecList.Hand.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Hand list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Hand.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Hand.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Hand.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadHandItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Hand.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Hand.Count = UpgradeListDBVar.char.PrimarySpecList.Hand.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Hand list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadHandItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Hand.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Hand list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Hand.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Hand.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Hand.Count = UpgradeListDBVar.char.SecondarySpecList.Hand.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Hand list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Hand.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Hand.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Hand.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadHandItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Hand.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Hand.Count = UpgradeListDBVar.char.SecondarySpecList.Hand.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Hand list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadHandItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 8 then --If the Waist tab is selected
		if ViewPrimarySpec:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Waist.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Waist list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Waist.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Waist.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Waist.Count = UpgradeListDBVar.char.PrimarySpecList.Waist.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Waist list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Waist.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Waist.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Waist.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadWaistItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Waist.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Waist.Count = UpgradeListDBVar.char.PrimarySpecList.Waist.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Waist list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadWaistItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Waist.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Waist list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Waist.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Waist.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Waist.Count = UpgradeListDBVar.char.SecondarySpecList.Waist.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Waist list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Waist.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Waist.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Waist.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadWaistItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Waist.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Waist.Count = UpgradeListDBVar.char.SecondarySpecList.Waist.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Waist list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadWaistItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 9 then --If the Leg tab is selected
		if ViewPrimarySpec:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Leg.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Leg list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Leg.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Leg.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Leg.Count = UpgradeListDBVar.char.PrimarySpecList.Leg.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Leg list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Leg.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Leg.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Leg.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadLegItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Leg.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Leg.Count = UpgradeListDBVar.char.PrimarySpecList.Leg.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Leg list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadLegItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Leg.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Leg list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Leg.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Leg.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Leg.Count = UpgradeListDBVar.char.SecondarySpecList.Leg.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Leg list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Leg.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Leg.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Leg.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadLegItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Leg.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Leg.Count = UpgradeListDBVar.char.SecondarySpecList.Leg.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Leg list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadLegItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 10 then --If the Foot tab is selected
		if ViewPrimarySpec:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Foot.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Foot list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Foot.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Foot.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Foot.Count = UpgradeListDBVar.char.PrimarySpecList.Foot.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Foot list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Foot.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Foot.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Foot.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadFootItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Foot.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Foot.Count = UpgradeListDBVar.char.PrimarySpecList.Foot.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Foot list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadFootItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Foot.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Foot list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Foot.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Foot.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Foot.Count = UpgradeListDBVar.char.SecondarySpecList.Foot.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Foot list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Foot.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Foot.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Foot.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadFootItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Foot.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Foot.Count = UpgradeListDBVar.char.SecondarySpecList.Foot.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Foot list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadFootItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 11 then --If the Ring tab is selected
		if ViewPrimarySpec:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Ring.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Ring list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Ring.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Ring.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Ring.Count = UpgradeListDBVar.char.PrimarySpecList.Ring.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Ring list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Ring.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Ring.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Ring.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadRingItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Ring.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Ring.Count = UpgradeListDBVar.char.PrimarySpecList.Ring.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Ring list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadRingItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Ring.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Ring list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Ring.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Ring.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Ring.Count = UpgradeListDBVar.char.SecondarySpecList.Ring.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Ring list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Ring.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Ring.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Ring.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadRingItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Ring.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Ring.Count = UpgradeListDBVar.char.SecondarySpecList.Ring.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Ring list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadRingItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 12 then --If the Trinket tab is selected
		if ViewPrimarySpec:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Trinket.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Trinket list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Trinket.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Trinket.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Trinket.Count = UpgradeListDBVar.char.PrimarySpecList.Trinket.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Trinket list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Trinket.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadTrinketItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Trinket.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Trinket.Count = UpgradeListDBVar.char.PrimarySpecList.Trinket.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Trinket list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadTrinketItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Trinket.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Trinket list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Trinket.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Trinket.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Trinket.Count = UpgradeListDBVar.char.SecondarySpecList.Trinket.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Trinket list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Trinket.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadTrinketItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Trinket.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Trinket.Count = UpgradeListDBVar.char.SecondarySpecList.Trinket.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Trinket list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadTrinketItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 13 then --If the Main tab is selected
		if ViewPrimarySpec:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Main.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Main list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Main.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Main.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Main.Count = UpgradeListDBVar.char.PrimarySpecList.Main.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Main Hand list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Main.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Main.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Main.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadMainItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Main.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Main.Count = UpgradeListDBVar.char.PrimarySpecList.Main.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Main Hand list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadMainItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Main.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Main list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Main.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Main.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Main.Count = UpgradeListDBVar.char.SecondarySpecList.Main.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Main Hand list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Main.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Main.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Main.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadMainItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Main.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Main.Count = UpgradeListDBVar.char.SecondarySpecList.Main.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Main Hand list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadMainItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 14 then --If the Off tab is selected
		if ViewPrimarySpec:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Off.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Off list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Off.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Off.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Off.Count = UpgradeListDBVar.char.PrimarySpecList.Off.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Off Hand list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Off.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Off.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Off.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadOffItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Off.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Off.Count = UpgradeListDBVar.char.PrimarySpecList.Off.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Off Hand list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadOffItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Off.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Off list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Off.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Off.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Off.Count = UpgradeListDBVar.char.SecondarySpecList.Off.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Off Hand list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Off.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Off.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Off.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadOffItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Off.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Off.Count = UpgradeListDBVar.char.SecondarySpecList.Off.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Off Hand list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadOffItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 15 then --If the Ranged tab is selected
		if ViewPrimarySpec:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Ranged.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Ranged list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Ranged.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Ranged.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Ranged.Count = UpgradeListDBVar.char.PrimarySpecList.Ranged.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Ranged list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Ranged.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadRangedItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Ranged.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Ranged.Count = UpgradeListDBVar.char.PrimarySpecList.Ranged.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Ranged list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadRangedItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Ranged.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Ranged list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Ranged.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Ranged.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Ranged.Count = UpgradeListDBVar.char.SecondarySpecList.Ranged.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Ranged list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Ranged.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadRangedItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Ranged.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Ranged.Count = UpgradeListDBVar.char.SecondarySpecList.Ranged.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Ranged list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadRangedItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 16 then --If the Other tab is selected
		if ViewPrimarySpec:GetChecked() == 1 then --If the primary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.PrimarySpecList.Other.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Primary Spec's Other list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.PrimarySpecList.Other.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Other.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Other.Count = UpgradeListDBVar.char.PrimarySpecList.Other.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Other list.");
				for i = UpgradeListDBVar.char.PrimarySpecList.Other.Row[deletefieldnum][1], UpgradeListDBVar.char.PrimarySpecList.Other.Count, 1 do
					UpgradeListDBVar.char.PrimarySpecList.Other.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadOtherItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.PrimarySpecList.Other.Row, deletefieldnum);
				UpgradeListDBVar.char.PrimarySpecList.Other.Count = UpgradeListDBVar.char.PrimarySpecList.Other.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Primary Spec's Other list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadOtherItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		else --The secondary spec checkbox is checked
			if deletefieldnum >= UpgradeListDBVar.char.SecondarySpecList.Other.Count or deletefieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Delete field does not match an item in your Secondary Spec's Other list.");
				deletefield:HighlightText();
			elseif deletefieldnum ~= UpgradeListDBVar.char.SecondarySpecList.Other.Count - 1 then --If the deletefieldnum is equal to the last displayed item in the list, it breaks the array
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Other.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Other.Count = UpgradeListDBVar.char.SecondarySpecList.Other.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Other list.");
				for i = UpgradeListDBVar.char.SecondarySpecList.Other.Row[deletefieldnum][1], UpgradeListDBVar.char.SecondarySpecList.Other.Count, 1 do
					UpgradeListDBVar.char.SecondarySpecList.Other.Row[i - 1][1] = i - 1;
				end
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadOtherItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			else --Deleting the last item in the list
				table.remove(UpgradeListDBVar.char.SecondarySpecList.Other.Row, deletefieldnum);
				UpgradeListDBVar.char.SecondarySpecList.Other.Count = UpgradeListDBVar.char.SecondarySpecList.Other.Count - 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully deleted item " .. deletefieldnum .. " from your Secondary Spec's Other list.");
				deletefield:SetText("");
				deletefield:ClearFocus();
				LoadOtherItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		end
	else
		statusbarfont:SetTextColor(1, 0, 0);
		statusbarfont:SetText(deletefield:GetText() .. " is not a valid number for the delete number.");
	end
end

local function MoveItem(fromfield, tofield, UpgradeListMainFrame, tableUL)
	local fromfieldnum = tonumber(fromfield:GetText());
	local tofieldnum = tonumber(tofield:GetText());
	if fromfieldnum ~= nil and tofieldnum ~= nil then
		fromfieldnum = math.floor(fromfieldnum);
		tofieldnum = math.floor(tofieldnum);
	end
	if fromfieldnum == nil and fromfield:GetText() ~= "" then
		statusbarfont:SetTextColor(1, 0, 0);
		statusbarfont:SetText("From field must be a number.");
		fromfield:HighlightText();
	elseif tofieldnum == nil and tofield:GetText() ~= "" then
		statusbarfont:SetTextColor(1, 0, 0);
		statusbarfont:SetText("To field must be a number.");
		tofield:HighlightText();
	elseif fromfieldnum == nil then
		statusbarfont:SetTextColor(1, 0, 0);
		statusbarfont:SetText("Nothing entered in from field.");
		fromfield:HighlightText();
	elseif tofieldnum == nil then
		statusbarfont:SetTextColor(1, 0, 0);
		statusbarfont:SetText("Nothing entered in to field.");
		tofield:HighlightText();
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 1 then --If the head tab is selected
		if ViewPrimarySpec:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Head.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Head list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Head.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Head list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
			--elseif fromfieldnum < UpgradeListDBVar.char.PrimarySpecList.Head.Count and fromfieldnum > 0 and tofieldnum < UpgradeListDBVar.char.PrimarySpecList.Head.Count and tofieldnum > 0 then --If the from & to numbers are in the list
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Head.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Head.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Head.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Head.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Head.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Head.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Head.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Head.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Head.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Head.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Head list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				LoadHeadItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Head.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Head list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Head.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Head list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
			--elseif fromfieldnum < UpgradeListDBVar.char.SecondarySpecList.Head.Count and fromfieldnum > 0 and tofieldnum < UpgradeListDBVar.char.SecondarySpecList.Head.Count and tofieldnum > 0 then --If the from & to numbers are in the list
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Head.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Head.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Head.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Head.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Head.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Head.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Head.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Head.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Head.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Head.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Head list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				LoadHeadItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 2 then --If the Neck tab is selected
		if ViewPrimarySpec:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Neck.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Neck list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Neck.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Neck list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
			--elseif fromfieldnum < UpgradeListDBVar.char.PrimarySpecList.Neck.Count and fromfieldnum > 0 and tofieldnum < UpgradeListDBVar.char.PrimarySpecList.Neck.Count and tofieldnum > 0 then --If the from & to numbers are in the list
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Neck.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Neck.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Neck.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Neck.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Neck.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Neck.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Neck.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Neck.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Neck.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Neck.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Neck list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				LoadNeckItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Neck.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Neck list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Neck.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Neck list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
			--elseif fromfieldnum < UpgradeListDBVar.char.SecondarySpecList.Neck.Count and fromfieldnum > 0 and tofieldnum < UpgradeListDBVar.char.SecondarySpecList.Neck.Count and tofieldnum > 0 then --If the from & to numbers are in the list
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Neck.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Neck.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Neck.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Neck.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Neck.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Neck.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Neck.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Neck.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Neck.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Neck.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Neck list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				LoadNeckItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		end
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 3 then --If the Shoulder tab is selected
		if ViewPrimarySpec:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Shoulder list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Shoulder list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
			--elseif fromfieldnum < UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count and fromfieldnum > 0 and tofieldnum < UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count and tofieldnum > 0 then --If the from & to numbers are in the list
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Shoulder list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				LoadShoulderItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Shoulder list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Shoulder list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
			--elseif fromfieldnum < UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count and fromfieldnum > 0 and tofieldnum < UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count and tofieldnum > 0 then --If the from & to numbers are in the list
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Shoulder list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				LoadShoulderItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 4 then --If the Back tab is selected
		if ViewPrimarySpec:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Back.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Back list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Back.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Back list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
			--elseif fromfieldnum < UpgradeListDBVar.char.PrimarySpecList.Back.Count and fromfieldnum > 0 and tofieldnum < UpgradeListDBVar.char.PrimarySpecList.Back.Count and tofieldnum > 0 then --If the from & to numbers are in the list
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Back.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Back.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Back.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Back.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Back.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Back.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Back.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Back.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Back.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Back.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Back list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				LoadBackItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Back.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Back list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Back.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Back list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
			--elseif fromfieldnum < UpgradeListDBVar.char.SecondarySpecList.Back.Count and fromfieldnum > 0 and tofieldnum < UpgradeListDBVar.char.SecondarySpecList.Back.Count and tofieldnum > 0 then --If the from & to numbers are in the list
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Back.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Back.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Back.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Back.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Back.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Back.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Back.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Back.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Back.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Back.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Back list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				LoadBackItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		end
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 5 then --If the Chest tab is selected
		if ViewPrimarySpec:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Chest.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Chest list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Chest.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Chest list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
			--elseif fromfieldnum < UpgradeListDBVar.char.PrimarySpecList.Chest.Count and fromfieldnum > 0 and tofieldnum < UpgradeListDBVar.char.PrimarySpecList.Chest.Count and tofieldnum > 0 then --If the from & to numbers are in the list
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Chest.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Chest.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Chest.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Chest.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Chest.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Chest.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Chest.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Chest.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Chest.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Chest.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Chest list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				LoadChestItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Chest.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Chest list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Chest.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Chest list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
			--elseif fromfieldnum < UpgradeListDBVar.char.SecondarySpecList.Chest.Count and fromfieldnum > 0 and tofieldnum < UpgradeListDBVar.char.SecondarySpecList.Chest.Count and tofieldnum > 0 then --If the from & to numbers are in the list
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Chest.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Chest.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Chest.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Chest.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Chest.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Chest.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Chest.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Chest.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Chest.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Chest.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Chest list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				LoadChestItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 6 then --If the Wrist tab is selected
		if ViewPrimarySpec:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Wrist.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Wrist list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Wrist.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Wrist list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
			--elseif fromfieldnum < UpgradeListDBVar.char.PrimarySpecList.Wrist.Count and fromfieldnum > 0 and tofieldnum < UpgradeListDBVar.char.PrimarySpecList.Wrist.Count and tofieldnum > 0 then --If the from & to numbers are in the list
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Wrist.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Wrist.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Wrist.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Wrist.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Wrist.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Wrist.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Wrist list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				LoadWristItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Wrist.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Wrist list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Wrist.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Wrist list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
			--elseif fromfieldnum < UpgradeListDBVar.char.SecondarySpecList.Wrist.Count and fromfieldnum > 0 and tofieldnum < UpgradeListDBVar.char.SecondarySpecList.Wrist.Count and tofieldnum > 0 then --If the from & to numbers are in the list
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Wrist.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Wrist.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Wrist.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Wrist.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Wrist.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Wrist.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Wrist list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				LoadWristItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 7 then --If the Hand tab is selected
		if ViewPrimarySpec:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Hand.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Hand list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Hand.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Hand list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
			--elseif fromfieldnum < UpgradeListDBVar.char.PrimarySpecList.Hand.Count and fromfieldnum > 0 and tofieldnum < UpgradeListDBVar.char.PrimarySpecList.Hand.Count and tofieldnum > 0 then --If the from & to numbers are in the list
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Hand.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Hand.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Hand.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Hand.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Hand.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Hand.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Hand.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Hand.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Hand.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Hand.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Hand list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				LoadHandItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Hand.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Hand list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Hand.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Hand list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
			--elseif fromfieldnum < UpgradeListDBVar.char.SecondarySpecList.Hand.Count and fromfieldnum > 0 and tofieldnum < UpgradeListDBVar.char.SecondarySpecList.Hand.Count and tofieldnum > 0 then --If the from & to numbers are in the list
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Hand.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Hand.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Hand.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Hand.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Hand.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Hand.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Hand.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Hand.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Hand.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Hand.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Hand list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				LoadHandItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 8 then --If the Waist tab is selected
		if ViewPrimarySpec:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Waist.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Waist list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Waist.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Waist list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
			--elseif fromfieldnum < UpgradeListDBVar.char.PrimarySpecList.Waist.Count and fromfieldnum > 0 and tofieldnum < UpgradeListDBVar.char.PrimarySpecList.Waist.Count and tofieldnum > 0 then --If the from & to numbers are in the list
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Waist.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Waist.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Waist.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Waist.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Waist.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Waist.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Waist.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Waist.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Waist.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Waist.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Waist list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				LoadWaistItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Waist.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Waist list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Waist.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Waist list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
			--elseif fromfieldnum < UpgradeListDBVar.char.SecondarySpecList.Waist.Count and fromfieldnum > 0 and tofieldnum < UpgradeListDBVar.char.SecondarySpecList.Waist.Count and tofieldnum > 0 then --If the from & to numbers are in the list
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Waist.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Waist.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Waist.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Waist.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Waist.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Waist.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Waist.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Waist.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Waist.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Waist.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Waist list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				LoadWaistItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 9 then --If the Leg tab is selected
		if ViewPrimarySpec:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Leg.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Leg list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Leg.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Leg list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
			--elseif fromfieldnum < UpgradeListDBVar.char.PrimarySpecList.Leg.Count and fromfieldnum > 0 and tofieldnum < UpgradeListDBVar.char.PrimarySpecList.Leg.Count and tofieldnum > 0 then --If the from & to numbers are in the list
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Leg.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Leg.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Leg.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Leg.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Leg.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Leg.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Leg.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Leg.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Leg.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Leg.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Leg list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				LoadLegItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Leg.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Leg list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Leg.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Leg list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
			--elseif fromfieldnum < UpgradeListDBVar.char.SecondarySpecList.Leg.Count and fromfieldnum > 0 and tofieldnum < UpgradeListDBVar.char.SecondarySpecList.Leg.Count and tofieldnum > 0 then --If the from & to numbers are in the list
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Leg.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Leg.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Leg.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Leg.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Leg.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Leg.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Leg.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Leg.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Leg.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Leg.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Leg list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				LoadLegItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 10 then --If the Foot tab is selected
		if ViewPrimarySpec:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Foot.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Foot list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Foot.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Foot list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
			--elseif fromfieldnum < UpgradeListDBVar.char.PrimarySpecList.Foot.Count and fromfieldnum > 0 and tofieldnum < UpgradeListDBVar.char.PrimarySpecList.Foot.Count and tofieldnum > 0 then --If the from & to numbers are in the list
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Foot.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Foot.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Foot.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Foot.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Foot.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Foot.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Foot.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Foot.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Foot.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Foot.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Foot list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				LoadFootItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Foot.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Foot list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Foot.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Foot list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
			--elseif fromfieldnum < UpgradeListDBVar.char.SecondarySpecList.Foot.Count and fromfieldnum > 0 and tofieldnum < UpgradeListDBVar.char.SecondarySpecList.Foot.Count and tofieldnum > 0 then --If the from & to numbers are in the list
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Foot.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Foot.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Foot.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Foot.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Foot.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Foot.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Foot.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Foot.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Foot.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Foot.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Foot list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				LoadFootItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 11 then --If the Ring tab is selected
		if ViewPrimarySpec:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Ring.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Ring list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Ring.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Ring list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
			--elseif fromfieldnum < UpgradeListDBVar.char.PrimarySpecList.Ring.Count and fromfieldnum > 0 and tofieldnum < UpgradeListDBVar.char.PrimarySpecList.Ring.Count and tofieldnum > 0 then --If the from & to numbers are in the list
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Ring.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Ring.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Ring.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Ring.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Ring.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Ring.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Ring.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Ring.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Ring.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Ring.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Ring list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				LoadRingItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Ring.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Ring list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Ring.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Ring list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
			--elseif fromfieldnum < UpgradeListDBVar.char.SecondarySpecList.Ring.Count and fromfieldnum > 0 and tofieldnum < UpgradeListDBVar.char.SecondarySpecList.Ring.Count and tofieldnum > 0 then --If the from & to numbers are in the list
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Ring.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Ring.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Ring.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Ring.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Ring.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Ring.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Ring.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Ring.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Ring.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Ring.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Ring list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				LoadRingItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 12 then --If the Trinket tab is selected
		if ViewPrimarySpec:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Trinket.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Trinket list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Trinket.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Trinket list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
			--elseif fromfieldnum < UpgradeListDBVar.char.PrimarySpecList.Trinket.Count and fromfieldnum > 0 and tofieldnum < UpgradeListDBVar.char.PrimarySpecList.Trinket.Count and tofieldnum > 0 then --If the from & to numbers are in the list
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Trinket.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Trinket.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Trinket.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Trinket.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Trinket.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Trinket.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Trinket list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				LoadTrinketItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Trinket.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Trinket list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Trinket.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Trinket list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
			--elseif fromfieldnum < UpgradeListDBVar.char.SecondarySpecList.Trinket.Count and fromfieldnum > 0 and tofieldnum < UpgradeListDBVar.char.SecondarySpecList.Trinket.Count and tofieldnum > 0 then --If the from & to numbers are in the list
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Trinket.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Trinket.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Trinket.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Trinket.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Trinket.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Trinket.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Trinket list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				LoadTrinketItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 13 then --If the Main tab is selected
		if ViewPrimarySpec:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Main.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Main list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Main.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Main list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
			--elseif fromfieldnum < UpgradeListDBVar.char.PrimarySpecList.Main.Count and fromfieldnum > 0 and tofieldnum < UpgradeListDBVar.char.PrimarySpecList.Main.Count and tofieldnum > 0 then --If the from & to numbers are in the list
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Main.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Main.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Main.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Main.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Main.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Main.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Main.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Main.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Main list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				LoadMainItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Main.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Main list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Main.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Main list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
			--elseif fromfieldnum < UpgradeListDBVar.char.SecondarySpecList.Main.Count and fromfieldnum > 0 and tofieldnum < UpgradeListDBVar.char.SecondarySpecList.Main.Count and tofieldnum > 0 then --If the from & to numbers are in the list
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Main.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Main.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Main.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Main.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Main.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Main.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Main.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Main.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Main list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				LoadMainItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 14 then --If the Off tab is selected
		if ViewPrimarySpec:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Off.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Off list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Off.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Off list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
			--elseif fromfieldnum < UpgradeListDBVar.char.PrimarySpecList.Off.Count and fromfieldnum > 0 and tofieldnum < UpgradeListDBVar.char.PrimarySpecList.Off.Count and tofieldnum > 0 then --If the from & to numbers are in the list
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Off.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Off.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Off.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Off.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Off.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Off.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Off.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Off.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Off list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				LoadOffItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Off.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Off list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Off.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Off list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
			--elseif fromfieldnum < UpgradeListDBVar.char.SecondarySpecList.Off.Count and fromfieldnum > 0 and tofieldnum < UpgradeListDBVar.char.SecondarySpecList.Off.Count and tofieldnum > 0 then --If the from & to numbers are in the list
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Off.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Off.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Off.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Off.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Off.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Off.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Off.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Off.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Off list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				LoadOffItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 15 then --If the Ranged tab is selected
		if ViewPrimarySpec:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Ranged.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Ranged list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Ranged.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Ranged list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
			--elseif fromfieldnum < UpgradeListDBVar.char.PrimarySpecList.Ranged.Count and fromfieldnum > 0 and tofieldnum < UpgradeListDBVar.char.PrimarySpecList.Ranged.Count and tofieldnum > 0 then --If the from & to numbers are in the list
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Ranged.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Ranged.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Ranged.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Ranged.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Ranged.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Ranged.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Ranged list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				LoadRangedItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Ranged.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Ranged list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Ranged.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Ranged list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
			--elseif fromfieldnum < UpgradeListDBVar.char.SecondarySpecList.Ranged.Count and fromfieldnum > 0 and tofieldnum < UpgradeListDBVar.char.SecondarySpecList.Ranged.Count and tofieldnum > 0 then --If the from & to numbers are in the list
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Ranged.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Ranged.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Ranged.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Ranged.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Ranged.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Ranged.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Ranged list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				LoadRangedItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		end
	elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 16 then --If the Other tab is selected
		if ViewPrimarySpec:GetChecked() == 1 then --If the primary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.PrimarySpecList.Other.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Primary Spec's Other list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.PrimarySpecList.Other.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Primary Spec's Other list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
			--elseif fromfieldnum < UpgradeListDBVar.char.PrimarySpecList.Other.Count and fromfieldnum > 0 and tofieldnum < UpgradeListDBVar.char.PrimarySpecList.Other.Count and tofieldnum > 0 then --If the from & to numbers are in the list
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Other.Row, tofieldnum, UpgradeListDBVar.char.PrimarySpecList.Other.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Other.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Other.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Other.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Other.Row, tofieldnum + 1, UpgradeListDBVar.char.PrimarySpecList.Other.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.PrimarySpecList.Other.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.PrimarySpecList.Other.Row, 1 do
						UpgradeListDBVar.char.PrimarySpecList.Other.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Primary Spec's Other list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				LoadOtherItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		else --If the Secondary spec checkbox is checked
			if fromfieldnum >= UpgradeListDBVar.char.SecondarySpecList.Other.Count or fromfieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From field does not match an item in your Secondary Spec's Other list.");
				fromfield:HighlightText();
			elseif tofieldnum >= UpgradeListDBVar.char.SecondarySpecList.Other.Count or tofieldnum == 0 then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("To field does not match an item in your Secondary Spec's Other list.");
				tofield:HighlightText();
			elseif tofieldnum == fromfieldnum then
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("From Field and To Field match, cannot move any items.");
				tofield:HighlightText();
			else
			--elseif fromfieldnum < UpgradeListDBVar.char.SecondarySpecList.Other.Count and fromfieldnum > 0 and tofieldnum < UpgradeListDBVar.char.SecondarySpecList.Other.Count and tofieldnum > 0 then --If the from & to numbers are in the list
				if fromfieldnum > tofieldnum then
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Other.Row, tofieldnum, UpgradeListDBVar.char.SecondarySpecList.Other.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Other.Row, fromfieldnum + 1);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Other.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Other.Row[i][1] = i;
					end
				else
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Other.Row, tofieldnum + 1, UpgradeListDBVar.char.SecondarySpecList.Other.Row[fromfieldnum]);
					table.remove(UpgradeListDBVar.char.SecondarySpecList.Other.Row, fromfieldnum);
					for i = 1, #UpgradeListDBVar.char.SecondarySpecList.Other.Row, 1 do
						UpgradeListDBVar.char.SecondarySpecList.Other.Row[i][1] = i;
					end
				end
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully moved row " .. fromfieldnum .. " to row " .. tofieldnum .. " in your Secondary Spec's Other list.");
				fromfield:SetText("");
				fromfield:ClearFocus();
				tofield:SetText("");
				tofield:ClearFocus();
				LoadOtherItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
			end
		end
	else
		statusbarfont:SetTextColor(1, 0, 0);
		statusbarfont:SetText("ERROR: Unable to determine selected tab.");
	end
end

local function ToggleOptions()
	if OptionsFrame:IsShown() then
		OptionsFrame:Hide()
	else
		OptionsFrame:Show()
	end
end

function UpgradeList:OnEnable()
	--Register for Events
	--local eventframe = CreateFrame("Frame", "EventFrame");
	--eventframe:RegisterEvent("ADDON_LOADED");


	--Create Main Frame (UpgradeListMainFrame)
	local UpgradeListMainFrame = CreateFrame("Frame","UpgradeListMainFrame",UIParent);
	UpgradeListMainFrame:SetFrameStrata("DIALOG");
	UpgradeListMainFrame:SetWidth(1257);
	UpgradeListMainFrame:SetHeight(280);
	
	UpgradeListMainFrame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", 
		edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",
		tile = true, tileSize = 32, edgeSize = 32, 
		insets = { left = 11, right = 11, top = 10, bottom = 10 }});

	UpgradeListMainFrame:SetBackdropColor(0,0,0,1);

	UpgradeListMainFrame:SetPoint("TOP",0,-80);
	
	--Makes the Main Frame (and therefore all frames attached to it) draggable
	UpgradeListMainFrame:SetMovable(true)
	UpgradeListMainFrame:EnableMouse(true)
	UpgradeListMainFrame:RegisterForDrag("LeftButton")
	UpgradeListMainFrame:SetScript("OnDragStart", UpgradeListMainFrame.StartMoving)
	UpgradeListMainFrame:SetScript("OnDragStop", UpgradeListMainFrame.StopMovingOrSizing)


	--Make a title section for the Main Frame 
	local MF_titleBG = UpgradeListMainFrame:CreateTexture(nil,"ARTWORK");
	MF_titleBG:SetTexture("Interface/DialogFrame/UI-DialogBox-Header");
	MF_titleBG:SetWidth(280);
	MF_titleBG:SetHeight(64);
	MF_titleBG:SetPoint("TOP", UpgradeListMainFrame, 0, 12);
	UpgradeListMainFrame.texture = MF_titleBG;

	local MF_titleText = UpgradeListMainFrame:CreateFontString(nil, "ARTWORK", "GameFontNormalSmall");
	MF_titleText:SetText('Upgrade List');
	MF_titleText:SetPoint("TOP", UpgradeListMainFrame, 0, -3);
	
	--Version Identification
	VersionHeading = CreateFrame('Frame', "VersionHeading", UpgradeListMainFrame);
	VersionHeadingFont = VersionHeading:CreateFontString("VersionHeading", "ARTWORK", "GameFontWhiteTiny");
	VersionHeadingFont:SetText("v " .. UPGRADELIST_VERSION);
	VersionHeadingFont:SetPoint("TOPLEFT", UpgradeListMainFrame, "TOPLEFT", 13, -11);
	VersionHeadingFont:SetWidth(VersionHeadingFont:GetStringWidth() + 5);
	VersionHeadingFont:SetHeight(VersionHeadingFont:GetStringHeight());
	
	--Make an invisible frame within the Main Frame that will contain the tableUL
	local TableContainer = CreateFrame("Frame", "TableContainer", UpgradeListMainFrame);
	TableContainer:SetWidth(1265);
	TableContainer:SetHeight(235);
	TableContainer:SetPoint("TOPLEFT", UpgradeListMainFrame, "TOPLEFT", 0, -30);
	TableContainer:SetPoint("BOTTOMRIGHT", UpgradeListMainFrame, "BOTTOMRIGHT", 0, -12);

	
	--Create the tableUL by defining the columns, rows, height of the rows, then creating the tableUL
	local cols = {
		{  -- col 1
			name	= "Priority",
			width	= 42,
			defaultsort = "asc",
			align = "CENTER",
			bgcolor = {
				["r"] = 0.0, 
				["g"] = 0.0, 
				["b"] = 0.0, 
				["a"] = 1.0, 
			},
		},
		{  -- col 2
			name	= "iLvl",
			width	= 35,
			align = "CENTER",
			bgcolor = {
				["r"] = 0.0, 
				["g"] = 0.0, 
				["b"] = 0.0, 
				["a"] = 1.0, 
			},
		},
		{  -- col 3
			name	= "Item",
			width	= 240,
			align = "CENTER",
			bgcolor = {
				["r"] = 0.0, 
				["g"] = 0.0, 
				["b"] = 0.0, 
				["a"] = 1.0, 
			},
		},
		{  -- col 4
			name	= "Difficulty",
			width	= 80,
			align = "CENTER",
			bgcolor = {
				["r"] = 0.0, 
				["g"] = 0.0, 
				["b"] = 0.0, 
				["a"] = 1.0, 
			},
		},
		{  -- col 5
			name	= "Instance/Reputation/Point Type/Token",
			width	= 250,
			align = "CENTER",
			bgcolor = {
				["r"] = 0.0, 
				["g"] = 0.0, 
				["b"] = 0.0, 
				["a"] = 1.0, 
			},
		},
		{  -- col 6
			name	= "Boss/Reputation Level/Points Needed/Token Location",
			width	= 280,
			align = "CENTER",
			bgcolor = {
				["r"] = 0.0, 
				["g"] = 0.0, 
				["b"] = 0.0, 
				["a"] = 1.0, 
			},
		},
		{  -- col 7
			name	= "Note",
			width	= 280,
			align = "CENTER",
			bgcolor = {
				["r"] = 0.0, 
				["g"] = 0.0, 
				["b"] = 0.0, 
				["a"] = 1.0, 
			},
		},
	};

	local rows = 14
	local height = 15
	local ScrollingTable = LibStub("ScrollingTableUL");
	local tableUL = ScrollingTable:CreateST(cols, rows, height, nil, TableContainer); --tableUL
	
	--"Close" button
	local CloseButton = CreateFrame('Button', "CloseButton", UpgradeListMainFrame, "UIPanelCloseButton");
	CloseButton:SetPoint("TOPRIGHT", -1, -2);
	CloseButton:SetWidth(40);
	CloseButton:SetHeight(40);
	
	--"ToggleOptions" button
	local ToggleButton = CreateFrame('Button', "ToggleButton", UpgradeListMainFrame, "UIPanelButtonTemplate2");
	ToggleButton:SetPoint("RIGHT", CloseButton, "LEFT", 8, 0);
	ToggleButton:SetWidth(170);
	ToggleButton:SetHeight(20);
	ToggleButton:SetText("Toggle Options Window");
	ToggleButton:SetScript("OnClick", function (self, button, down)
		ToggleOptions();
	end);
	
	--"PrimarySpecView" button
	local ViewPrimarySpec = CreateFrame('CheckButton', "ViewPrimarySpec", UpgradeListMainFrame, "UICheckButtonTemplate");
	ViewPrimarySpec:SetPoint("RIGHT", ToggleButton, "LEFT", -275, -2);
	ViewPrimarySpec:SetChecked(true);
	_G[ViewPrimarySpec:GetName() .. "Text"]:SetText("View Primary Spec");
	ViewPrimarySpec:SetScript("OnClick", function (self, button, down)
		if GetNumTalentGroups("player") == 1 then
			ViewSecondarySpec:Disable();
			ViewPrimarySpec:SetChecked(true);
		else
			ViewSecondarySpec:SetChecked(false);
			if PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 1 then
				LoadHeadItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
			elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 2 then
				LoadNeckItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
			elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 3 then
				LoadShoulderItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
			elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 4 then
				LoadBackItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
			elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 5 then
				LoadChestItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
			elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 6 then
				LoadWristItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
			elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 7 then
				LoadHandItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
			elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 8 then
				LoadWaistItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
			elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 9 then
				LoadLegItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
			elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 10 then
				LoadFootItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
			elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 11 then
				LoadRingItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
			elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 12 then
				LoadTrinketItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
			elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 13 then
				LoadMainItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
			elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 14 then
				LoadOffItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
			elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 15 then
				LoadRangedItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
			elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 16 then
				LoadOtherItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
			else
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("ERROR: Unable to determine which gear tab is selected.");
			end
		end
	ViewPrimarySpec:SetChecked(true);
	end);
	
	--"SecondarySpecView" button
	local ViewSecondarySpec = CreateFrame('CheckButton', "ViewSecondarySpec", UpgradeListMainFrame, "UICheckButtonTemplate");
	ViewSecondarySpec:SetPoint("RIGHT", ToggleButton, "LEFT", -125, -2);
	ViewSecondarySpec:SetChecked(false);
	_G[ViewSecondarySpec:GetName() .. "Text"]:SetText("View Secondary Spec");
	if GetNumTalentGroups("player") == 1 then
		_G[ViewSecondarySpec:GetName() .. "Text"]:SetTextColor(0.5, 0.5, 0.5);
		ViewSecondarySpec:Disable();
	end
	ViewSecondarySpec:SetScript("OnClick", function (self, button, down)
		ViewSecondarySpec:SetChecked(true);
		ViewPrimarySpec:SetChecked(false);
		if PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 1 then
			LoadHeadItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 2 then
			LoadNeckItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 3 then
			LoadShoulderItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 4 then
			LoadBackItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 5 then
			LoadChestItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 6 then
			LoadWristItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 7 then
			LoadHandItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 8 then
			LoadWaistItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 9 then
			LoadLegItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 10 then
			LoadFootItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 11 then
			LoadRingItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 12 then
			LoadTrinketItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 13 then
			LoadMainItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 14 then
			LoadOffItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 15 then
			LoadRangedItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
		elseif PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 16 then
			LoadOtherItems(tableUL, ViewPrimarySpec, ViewSecondarySpec)
		else
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("ERROR: Unable to determine which gear tab is selected.");
		end
	end);

	--Create all the 16 tabs for the equipment slots
	PanelTemplates_SetNumTabs(UpgradeListMainFrame, 16);
	local Tab_1 = CreateFrame('Button', "$parentTab1", UpgradeListMainFrame, "CharacterFrameTabButtonTemplate");
	Tab_1:SetID(1);
	Tab_1:SetText('Head');
	Tab_1:SetPoint("BOTTOMLEFT", 5, -25);
	PanelTemplates_TabResize(Tab_1, 0, 93, 94);
	Tab_1:RegisterForClicks("AnyUp");
	Tab_1:SetScript("OnClick", function (self, button, down)
		self:SetID(self:GetID());
		PanelTemplates_Tab_OnClick(Tab_1, UpgradeListMainFrame);
		LoadHeadItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
	end);

	local Tab_2 = CreateFrame('Button', "$parentTab2", UpgradeListMainFrame, "CharacterFrameTabButtonTemplate");
	Tab_2:SetID(2);
	Tab_2:SetText('Neck');
	Tab_2:SetPoint("LEFT", Tab_1, "RIGHT", -17, 0);
	PanelTemplates_TabResize(Tab_2, 0, 93, 94);
	Tab_2:RegisterForClicks("AnyUp");
	Tab_2:SetScript("OnClick", function (self, button, down)
		self:SetID(self:GetID());
		PanelTemplates_Tab_OnClick(Tab_2, UpgradeListMainFrame);
		LoadNeckItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
	end);
	
	local Tab_3 = CreateFrame('Button', "$parentTab3", UpgradeListMainFrame, "CharacterFrameTabButtonTemplate");
	Tab_3:SetID(3);
	Tab_3:SetText('Shoulders');
	Tab_3:SetPoint("LEFT", Tab_2, "RIGHT", -17, 0);
	PanelTemplates_TabResize(Tab_3, 0, 93, 94);
	Tab_3:RegisterForClicks("AnyUp");
	Tab_3:SetScript("OnClick", function (self, button, down)
		self:SetID(self:GetID());
		PanelTemplates_Tab_OnClick(Tab_3, UpgradeListMainFrame);
		LoadShoulderItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
	end);
	
	local Tab_4 = CreateFrame('Button', "$parentTab4", UpgradeListMainFrame, "CharacterFrameTabButtonTemplate");
	Tab_4:SetID(4);
	Tab_4:SetText('Back');
	Tab_4:SetPoint("LEFT", Tab_3, "RIGHT", -17, 0);
	PanelTemplates_TabResize(Tab_4, 0, 93, 94);
	Tab_4:RegisterForClicks("AnyUp");
	Tab_4:SetScript("OnClick", function (self, button, down)
		self:SetID(self:GetID());
		PanelTemplates_Tab_OnClick(Tab_4, UpgradeListMainFrame);
		LoadBackItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
	end);
	
	local Tab_5 = CreateFrame('Button', "$parentTab5", UpgradeListMainFrame, "CharacterFrameTabButtonTemplate");
	Tab_5:SetID(5);
	Tab_5:SetText('Chest');
	Tab_5:SetPoint("LEFT", Tab_4, "RIGHT", -17, 0);
	PanelTemplates_TabResize(Tab_5, 0, 93, 94);
	Tab_5:RegisterForClicks("AnyUp");
	Tab_5:SetScript("OnClick", function (self, button, down)
		self:SetID(self:GetID());
		PanelTemplates_Tab_OnClick(Tab_5, UpgradeListMainFrame);
		LoadChestItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
	end);
	
	local Tab_6 = CreateFrame('Button', "$parentTab6", UpgradeListMainFrame, "CharacterFrameTabButtonTemplate");
	Tab_6:SetID(6);
	Tab_6:SetText('Wrists');
	Tab_6:SetPoint("LEFT", Tab_5, "RIGHT", -17, 0);
	PanelTemplates_TabResize(Tab_6, 0, 93, 94);
	Tab_6:RegisterForClicks("AnyUp");
	Tab_6:SetScript("OnClick", function (self, button, down)
		self:SetID(self:GetID());
		PanelTemplates_Tab_OnClick(Tab_6, UpgradeListMainFrame);
		LoadWristItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
	end);
	
	local Tab_7 = CreateFrame('Button', "$parentTab7", UpgradeListMainFrame, "CharacterFrameTabButtonTemplate");
	Tab_7:SetID(7);
	Tab_7:SetText('Hands');
	Tab_7:SetPoint("LEFT", Tab_6, "RIGHT", -17, 0);
	PanelTemplates_TabResize(Tab_7, 0, 93, 94);
	Tab_7:RegisterForClicks("AnyUp");
	Tab_7:SetScript("OnClick", function (self, button, down)
		self:SetID(self:GetID());
		PanelTemplates_Tab_OnClick(Tab_7, UpgradeListMainFrame);
		LoadHandItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
	end);
	
	local Tab_8 = CreateFrame('Button', "$parentTab8", UpgradeListMainFrame, "CharacterFrameTabButtonTemplate");
	Tab_8:SetID(8);
	Tab_8:SetText('Waist');
	Tab_8:SetPoint("LEFT", Tab_7, "RIGHT", -17, 0);
	PanelTemplates_TabResize(Tab_8, 0, 93, 94);
	Tab_8:RegisterForClicks("AnyUp");
	Tab_8:SetScript("OnClick", function (self, button, down)
		self:SetID(self:GetID());
		PanelTemplates_Tab_OnClick(Tab_8, UpgradeListMainFrame);
		LoadWaistItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
	end);
	
	local Tab_9 = CreateFrame('Button', "$parentTab9", UpgradeListMainFrame, "CharacterFrameTabButtonTemplate");
	Tab_9:SetID(9);
	Tab_9:SetText('Legs');
	Tab_9:SetPoint("LEFT", Tab_8, "RIGHT", -17, 0);
	PanelTemplates_TabResize(Tab_9, 0, 93, 94);
	Tab_9:RegisterForClicks("AnyUp");
	Tab_9:SetScript("OnClick", function (self, button, down)
		self:SetID(self:GetID());
		PanelTemplates_Tab_OnClick(Tab_9, UpgradeListMainFrame);
		LoadLegItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
	end);
	
	local Tab_10 = CreateFrame('Button', "$parentTab10", UpgradeListMainFrame, "CharacterFrameTabButtonTemplate");
	Tab_10:SetID(10);
	Tab_10:SetText('Feet');
	Tab_10:SetPoint("LEFT", Tab_9, "RIGHT", -17, 0);
	PanelTemplates_TabResize(Tab_10, 0, 93, 94);
	Tab_10:RegisterForClicks("AnyUp");
	Tab_10:SetScript("OnClick", function (self, button, down)
		self:SetID(self:GetID());
		PanelTemplates_Tab_OnClick(Tab_10, UpgradeListMainFrame);
		LoadFootItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
	end);
	
	local Tab_11 = CreateFrame('Button', "$parentTab11", UpgradeListMainFrame, "CharacterFrameTabButtonTemplate");
	Tab_11:SetID(11);
	Tab_11:SetText('Rings');
	Tab_11:SetPoint("LEFT", Tab_10, "RIGHT", -17, 0);
	PanelTemplates_TabResize(Tab_11, 0, 93, 94);
	Tab_11:RegisterForClicks("AnyUp");
	Tab_11:SetScript("OnClick", function (self, button, down)
		self:SetID(self:GetID());
		PanelTemplates_Tab_OnClick(Tab_11, UpgradeListMainFrame);
		LoadRingItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
	end);
	
	local Tab_12 = CreateFrame('Button', "$parentTab12", UpgradeListMainFrame, "CharacterFrameTabButtonTemplate");
	Tab_12:SetID(12);
	Tab_12:SetText('Trinkets');
	Tab_12:SetPoint("LEFT", Tab_11, "RIGHT", -17, 0);
	PanelTemplates_TabResize(Tab_12, 0, 93, 94);
	Tab_12:RegisterForClicks("AnyUp");
	Tab_12:SetScript("OnClick", function (self, button, down)
		self:SetID(self:GetID());
		PanelTemplates_Tab_OnClick(Tab_12, UpgradeListMainFrame);
		LoadTrinketItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
	end);
	
	local Tab_13 = CreateFrame('Button', "$parentTab13", UpgradeListMainFrame, "CharacterFrameTabButtonTemplate");
	Tab_13:SetID(13);
	Tab_13:SetText('Main Hand');
	Tab_13:SetPoint("LEFT", Tab_12, "RIGHT", -17, 0);
	PanelTemplates_TabResize(Tab_13, 0, 102, 90);
	Tab_13:RegisterForClicks("AnyUp");
	Tab_13:SetScript("OnClick", function (self, button, down)
		self:SetID(self:GetID());
		PanelTemplates_Tab_OnClick(Tab_13, UpgradeListMainFrame);
		LoadMainItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
	end);
	
	local Tab_14 = CreateFrame('Button', "$parentTab14", UpgradeListMainFrame, "CharacterFrameTabButtonTemplate");
	Tab_14:SetID(14);
	Tab_14:SetText('Off Hand');
	Tab_14:SetPoint("LEFT", Tab_13, "RIGHT", -17, 0);
	PanelTemplates_TabResize(Tab_14, 0, 94, 94);
	Tab_14:RegisterForClicks("AnyUp");
	Tab_14:SetScript("OnClick", function (self, button, down)
		self:SetID(self:GetID());
		PanelTemplates_Tab_OnClick(Tab_14, UpgradeListMainFrame);
		LoadOffItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
	end);
	
	local Tab_15 = CreateFrame('Button', "$parentTab15", UpgradeListMainFrame, "CharacterFrameTabButtonTemplate");
	Tab_15:SetID(15);
	Tab_15:SetText('Ranged');
	Tab_15:SetPoint("LEFT", Tab_14, "RIGHT", -17, 0);
	PanelTemplates_TabResize(Tab_15, 0, 94, 94);
	Tab_15:RegisterForClicks("AnyUp");
	Tab_15:SetScript("OnClick", function (self, button, down)
		self:SetID(self:GetID());
		PanelTemplates_Tab_OnClick(Tab_15, UpgradeListMainFrame);
		LoadRangedItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
	end);
	
	local Tab_16 = CreateFrame('Button', "$parentTab16", UpgradeListMainFrame, "CharacterFrameTabButtonTemplate");
	Tab_16:SetID(16);
	Tab_16:SetText('Other');
	Tab_16:SetPoint("LEFT", Tab_15, "RIGHT", -17, 0);
	PanelTemplates_TabResize(Tab_16, 0, 94, 94);
	Tab_16:RegisterForClicks("AnyUp");
	Tab_16:SetScript("OnClick", function (self, button, down)
		self:SetID(self:GetID());
		PanelTemplates_Tab_OnClick(Tab_16, UpgradeListMainFrame);
		LoadOtherItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
	end);
	
	PanelTemplates_SetTab(UpgradeListMainFrame, 1);
	LoadHeadItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
	
	--Create the options frame below the main frame
	OptionsFrame = CreateFrame("Frame", "OptionsFrame", UpgradeListMainFrame);
	OptionsFrame:SetWidth(850);
	OptionsFrame:SetHeight(330);
	OptionsFrame:SetPoint("TOP",UpgradeListMainFrame,"BOTTOM", 0, -30);
	OptionsFrame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background", 
		edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",
		tile = true, tileSize = 32, edgeSize = 32, 
		insets = { left = 11, right = 12, top = 12, bottom = 11 }});
	
	--Creation of the Item Entry Box
	ItemEntryBox = CreateFrame('EditBox', "ItemEntryBox", OptionsFrame, "InputBoxTemplate");
	ItemEntryBox:SetPoint("CENTER", 0, 125);
	ItemEntryBox:SetAutoFocus(false);
	ItemEntryBox:SetWidth(130);
    ItemEntryBox:SetHeight(24);
	
	ItemEntryBoxHeading = CreateFrame('Frame', "ItemEntryBoxHeading", OptionsFrame);
	HeadingFont = ItemEntryBoxHeading:CreateFontString("ItemHeading", "ARTWORK", "GameFontNormalSmallLeft");
	HeadingFont:SetText("Enter your item with an item link or an item ID number:");
	HeadingFont:SetPoint("BOTTOM", ItemEntryBox, "TOP");
	HeadingFont:SetWidth(HeadingFont:GetStringWidth());
	HeadingFont:SetHeight(HeadingFont:GetStringHeight());	

	--Creation of the dropdown menus
	CreateFrame("Button", "DropDown_Button", OptionsFrame, "UIDropDownMenuTemplate")
	DropDown_Button:ClearAllPoints()
	DropDown_Button:SetPoint("TOP", ItemEntryBox, "BOTTOM", 0, -20)
	DropDown_Button:Show()
	

	function DropDown_InitializeDropDown(self, level)

		--Top Level
		if level == 1 then
			local info = UIDropDownMenu_CreateInfo()

			info = UIDropDownMenu_CreateInfo()
			info.text = "Raid"
			info.hasArrow = true
			info.value = "Raid"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)

			info = UIDropDownMenu_CreateInfo()
			info.text = "Dungeon"
			info.hasArrow = true
			info.value = "Dungeon"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info = UIDropDownMenu_CreateInfo()
			info.text = "Crafted"
			info.hasArrow = true
			info.value = "Crafted"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info = UIDropDownMenu_CreateInfo()
			info.text = "Quest Reward"
			info.hasArrow = true
			info.value = "Quest Reward"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info = UIDropDownMenu_CreateInfo()
			info.text = "Reputation Reward"
			info.hasArrow = true
			info.value = "Reputation Reward"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info = UIDropDownMenu_CreateInfo()
			info.text = "Purchasable"
			info.hasArrow = true
			info.value = "Purchasable"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info = UIDropDownMenu_CreateInfo()
			info.text = "World Drop"
			info.hasArrow = true
			info.value = "World Drop"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info = UIDropDownMenu_CreateInfo()
			info.text = "Other"
			info.notCheckable = 1
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Other");
				UPGRADELIST_SELECTEDINSTANCE = "Other";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Raid Submenu
		elseif (level == 2) and (UIDROPDOWNMENU_MENU_VALUE == "Raid") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Heroic"
			info.hasArrow = true
			info.value = "HeroicRaid"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info = UIDropDownMenu_CreateInfo()
			info.text = "Normal"
			info.hasArrow = true
			info.value = "NormalRaid"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
		--Dungeon Submenu
		elseif (level == 2) and (UIDROPDOWNMENU_MENU_VALUE == "Dungeon") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Heroic"
			info.hasArrow = true
			info.value = "HeroicDungeon"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Normal"
			info.hasArrow = true
			info.value = "NormalDungeon"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
		--Crafted Submenu
		elseif (level == 2) and (UIDROPDOWNMENU_MENU_VALUE == "Crafted") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Alchemy"
			info.value = "Alchemy"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Alchemy");
				UPGRADELIST_SELECTEDINSTANCE = "Alchemy";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Blacksmithing"
			info.value = "Blacksmithing"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Blacksmithing");
				UPGRADELIST_SELECTEDINSTANCE = "Blacksmithing";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Enchanting"
			info.value = "Enchanting"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Enchanting");
				UPGRADELIST_SELECTEDINSTANCE = "Enchanting";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Engineering"
			info.value = "Engineering"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Engineering");
				UPGRADELIST_SELECTEDINSTANCE = "Engineering";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Inscription"
			info.value = "Inscription"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Inscription");
				UPGRADELIST_SELECTEDINSTANCE = "Inscription";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Jewelcrafting"
			info.value = "Jewelcrafting"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Jewelcrafting");
				UPGRADELIST_SELECTEDINSTANCE = "Jewelcrafting";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Leatherworking"
			info.value = "Leatherworking"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Leatherworking");
				UPGRADELIST_SELECTEDINSTANCE = "Leatherworking";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Tailoring"
			info.value = "Tailoring"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Tailoring");
				UPGRADELIST_SELECTEDINSTANCE = "Tailoring";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Quest Reward Submenu
		elseif (level == 2) and (UIDROPDOWNMENU_MENU_VALUE == "Quest Reward") then
			local info = UIDropDownMenu_CreateInfo()
			--local DropLocation = "Quest Reward"
			
			info.text = "Quest Reward"
			info.value = "Quest Reward"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Quest Reward");
				UPGRADELIST_SELECTEDINSTANCE = "Quest Reward";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			
			
		--Reputation Reward Submenu
		elseif (level == 2) and (UIDROPDOWNMENU_MENU_VALUE == "Reputation Reward") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Guardians of Hyjal"
			info.hasArrow = true
			info.value = "Guardians of Hyjal"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "The Earthen Ring"
			info.hasArrow = true
			info.value = "The Earthen Ring"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Therazane"
			info.hasArrow = true
			info.value = "Therazane"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Ramkahen"
			info.hasArrow = true
			info.value = "Ramkahen"
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			--Check to see if player is Alliance or Horde & give them the correct reputation choices
			if UnitFactionGroup("player") == "Alliance" then
				info.text = "Wildhammer Clan"
				info.hasArrow = true
				info.value = "Wildhammer Clan"
				info.notCheckable = 1
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Baradin's Wardens"
				info.hasArrow = true
				info.value = "Baradin's Wardens"
				info.notCheckable = 1
				UIDropDownMenu_AddButton(info, level)
				
			elseif UnitFactionGroup("player") == "Horde" then
				info.text = "Dragonmaw Clan"
				info.hasArrow = true
				info.value = "Dragonmaw Clan"
				info.notCheckable = 1
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Hellscream's Reach"
				info.hasArrow = true
				info.value = "Hellscream's Reach"
				info.notCheckable = 1
				UIDropDownMenu_AddButton(info, level)
				
			else
				print ("UpgradeList: Unable to determine your faction!");
			end
			
			--Check to see if the player is in a guild, if they are they can select their guild from the dropdown
			if (IsInGuild()) then
				info.text = GetGuildInfo("player")
				info.hasArrow = true
				info.value = GetGuildInfo("player")
				info.notCheckable = 1
				UIDropDownMenu_AddButton(info, level)
			end
		
		--Purchasable Submenu
		elseif (level == 2) and (UIDROPDOWNMENU_MENU_VALUE == "Purchasable") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Valor Points"
			info.value = "Valor Points"
			info.notCheckable = 1
			function info.func()
				CloseDropDownMenus(1);
				UIDropDownMenu_SetSelectedName(DropDown_Button, "Valor Points");
				PointInput:Show();
				PointInputBox:SetFocus();
				UpgradeListMainFrame:EnableMouse(false)
				CloseButton:EnableMouse(false)
				ToggleButton:EnableMouse(false)
				ViewPrimarySpec:EnableMouse(false)
				ViewSecondarySpec:EnableMouse(false)
				OptionsFrame:EnableMouse(false)
				ItemEntryBox:EnableMouse(false)
				DropDown_Button:EnableMouse(false)
				NoteEntryBox:EnableMouse(false)
				PrimarySpecRadioButton:EnableMouse(false)
				SecondarySpecRadioButton:EnableMouse(false)
				priorityfield:EnableMouse(false)
				AddButton:EnableMouse(false)
				tofield:EnableMouse(false)
				fromfield:EnableMouse(false)
				MoveButton:EnableMouse(false)
				DeleteButton:EnableMouse(false)
				deletefield:EnableMouse(false)
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Justice Points"
			info.value = "Justice Points"
			info.notCheckable = 1
			function info.func()
				CloseDropDownMenus(1);
				UIDropDownMenu_SetSelectedName(DropDown_Button, "Justice Points");
				PointInput:Show();
				PointInputBox:SetFocus();
				UpgradeListMainFrame:EnableMouse(false)
				CloseButton:EnableMouse(false)
				ToggleButton:EnableMouse(false)
				ViewPrimarySpec:EnableMouse(false)
				ViewSecondarySpec:EnableMouse(false)
				OptionsFrame:EnableMouse(false)
				ItemEntryBox:EnableMouse(false)
				DropDown_Button:EnableMouse(false)
				NoteEntryBox:EnableMouse(false)
				PrimarySpecRadioButton:EnableMouse(false)
				SecondarySpecRadioButton:EnableMouse(false)
				priorityfield:EnableMouse(false)
				AddButton:EnableMouse(false)
				tofield:EnableMouse(false)
				fromfield:EnableMouse(false)
				MoveButton:EnableMouse(false)
				DeleteButton:EnableMouse(false)
				deletefield:EnableMouse(false)
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Conquest Points"
			info.value = "Conquest Points"
			info.notCheckable = 1
			function info.func()
				CloseDropDownMenus(1);
				UIDropDownMenu_SetSelectedName(DropDown_Button, "Conquest Points");
				PointInput:Show();
				PointInputBox:SetFocus();
				UpgradeListMainFrame:EnableMouse(false)
				CloseButton:EnableMouse(false)
				ToggleButton:EnableMouse(false)
				ViewPrimarySpec:EnableMouse(false)
				ViewSecondarySpec:EnableMouse(false)
				OptionsFrame:EnableMouse(false)
				ItemEntryBox:EnableMouse(false)
				DropDown_Button:EnableMouse(false)
				NoteEntryBox:EnableMouse(false)
				PrimarySpecRadioButton:EnableMouse(false)
				SecondarySpecRadioButton:EnableMouse(false)
				priorityfield:EnableMouse(false)
				AddButton:EnableMouse(false)
				tofield:EnableMouse(false)
				fromfield:EnableMouse(false)
				MoveButton:EnableMouse(false)
				DeleteButton:EnableMouse(false)
				deletefield:EnableMouse(false)
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Honor Points"
			info.value = "Honor Points"
			info.notCheckable = 1
			function info.func()
				CloseDropDownMenus(1);
				UIDropDownMenu_SetSelectedName(DropDown_Button, "Honor Points");
				PointInput:Show();
				PointInputBox:SetFocus();
				UpgradeListMainFrame:EnableMouse(false)
				CloseButton:EnableMouse(false)
				ToggleButton:EnableMouse(false)
				ViewPrimarySpec:EnableMouse(false)
				ViewSecondarySpec:EnableMouse(false)
				OptionsFrame:EnableMouse(false)
				ItemEntryBox:EnableMouse(false)
				DropDown_Button:EnableMouse(false)
				NoteEntryBox:EnableMouse(false)
				PrimarySpecRadioButton:EnableMouse(false)
				SecondarySpecRadioButton:EnableMouse(false)
				priorityfield:EnableMouse(false)
				AddButton:EnableMouse(false)
				tofield:EnableMouse(false)
				fromfield:EnableMouse(false)
				MoveButton:EnableMouse(false)
				DeleteButton:EnableMouse(false)
				deletefield:EnableMouse(false)
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Gear Token"
			info.value = "Gear Token"
			info.notCheckable = true
			info.hasArrow = true
			UIDropDownMenu_AddButton(info, level)
			
		--World Drop Submenu
		elseif (level == 2) and (UIDROPDOWNMENU_MENU_VALUE == "World Drop") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "World Drop"
			info.value = "World Drop"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "World Drop");
				UPGRADELIST_SELECTEDINSTANCE = "World Drop";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)

		--List of heroic raids
		elseif (level == 3) and (UIDROPDOWNMENU_MENU_VALUE == "HeroicRaid") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Baradin Hold"
			info.value = "Baradin Hold Heroic"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Bastion of Twilight"
			info.value = "Bastion of Twilight Heroic"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)

			info.text = "Blackwing Descent"
			info.value = "Blackwing Descent Heroic"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Throne of the Four Winds"
			info.value = "Throne of the Four Winds Heroic"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
		--List of normal raids
		elseif (level == 3) and (UIDROPDOWNMENU_MENU_VALUE == "NormalRaid") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Baradin Hold"
			info.value = "Baradin Hold Normal"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Bastion of Twilight"
			info.value = "Bastion of Twilight Normal"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)

			info.text = "Blackwing Descent"
			info.value = "Blackwing Descent Normal"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Throne of the Four Winds"
			info.value = "Throne of the Four Winds Normal"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
		
		--Heroic Dungeons
		elseif (level == 3) and (UIDROPDOWNMENU_MENU_VALUE == "HeroicDungeon") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Throne of the Tides"
			info.value = "Throne of the Tides Heroic"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Blackrock Caverns"
			info.value = "Blackrock Caverns Heroic"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "The Stonecore"
			info.value = "The Stonecore Heroic"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "The Vortex Pinnacle"
			info.value = "The Vortex Pinnacle Heroic"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Lost City of Tol'vir"
			info.value = "Lost City of Tol'vir Heroic"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Grim Batol"
			info.value = "Grim Batol Heroic"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Halls of Origination"
			info.value = "Halls of Origination Heroic"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "The Deadmines"
			info.value = "The Deadmines Heroic"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Shadowfang Keep"
			info.value = "Shadowfang Keep Heroic"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
		--Normal Dungeons
		elseif (level == 3) and (UIDROPDOWNMENU_MENU_VALUE == "NormalDungeon") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Throne of the Tides"
			info.value = "Throne of the Tides Normal"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Blackrock Caverns"
			info.value = "Blackrock Caverns Normal"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "The Stonecore"
			info.value = "The Stonecore Normal"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "The Vortex Pinnacle"
			info.value = "The Vortex Pinnacle Normal"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Lost City of Tol'vir"
			info.value = "Lost City of Tol'vir Normal"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Grim Batol"
			info.value = "Grim Batol Normal"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Halls of Origination"
			info.value = "Halls of Origination Normal"
			info.hasArrow = true
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
		--Guardians of Hyjal Rep
		elseif (level == 3) and (UIDROPDOWNMENU_MENU_VALUE == "Guardians of Hyjal") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Exalted"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Guardians of Hyjal");
				UPGRADELIST_SELECTEDBOSS = "Exalted";
				UPGRADELIST_SELECTEDINSTANCE = "Guardians of Hyjal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Revered"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Guardians of Hyjal");
				UPGRADELIST_SELECTEDBOSS = "Revered";
				UPGRADELIST_SELECTEDINSTANCE = "Guardians of Hyjal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Honored"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Guardians of Hyjal");
				UPGRADELIST_SELECTEDBOSS = "Honored";
				UPGRADELIST_SELECTEDINSTANCE = "Guardians of Hyjal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Friendly"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Guardians of Hyjal");
				UPGRADELIST_SELECTEDBOSS = "Friendly";
				UPGRADELIST_SELECTEDINSTANCE = "Guardians of Hyjal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--The Earthen Ring Rep
		elseif (level == 3) and (UIDROPDOWNMENU_MENU_VALUE == "The Earthen Ring") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Exalted"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "The Earthen Ring");
				UPGRADELIST_SELECTEDBOSS = "Exalted";
				UPGRADELIST_SELECTEDINSTANCE = "The Earthen Ring";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Revered"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "The Earthen Ring");
				UPGRADELIST_SELECTEDBOSS = "Revered";
				UPGRADELIST_SELECTEDINSTANCE = "The Earthen Ring";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Honored"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "The Earthen Ring");
				UPGRADELIST_SELECTEDBOSS = "Honored";
				UPGRADELIST_SELECTEDINSTANCE = "The Earthen Ring";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Friendly"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "The Earthen Ring");
				UPGRADELIST_SELECTEDBOSS = "Friendly";
				UPGRADELIST_SELECTEDINSTANCE = "The Earthen Ring";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Therazane Rep
		elseif (level == 3) and (UIDROPDOWNMENU_MENU_VALUE == "Therazane") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Exalted"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Therazane");
				UPGRADELIST_SELECTEDBOSS = "Exalted";
				UPGRADELIST_SELECTEDINSTANCE = "Therazane";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Revered"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Therazane");
				UPGRADELIST_SELECTEDBOSS = "Revered";
				UPGRADELIST_SELECTEDINSTANCE = "Therazane";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Honored"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Therazane");
				UPGRADELIST_SELECTEDBOSS = "Honored";
				UPGRADELIST_SELECTEDINSTANCE = "Therazane";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Friendly"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Therazane");
				UPGRADELIST_SELECTEDBOSS = "Friendly";
				UPGRADELIST_SELECTEDINSTANCE = "Therazane";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Ramkahen Rep
		elseif (level == 3) and (UIDROPDOWNMENU_MENU_VALUE == "Ramkahen") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Exalted"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Ramkahen");
				UPGRADELIST_SELECTEDBOSS = "Exalted";
				UPGRADELIST_SELECTEDINSTANCE = "Ramkahen";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Revered"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Ramkahen");
				UPGRADELIST_SELECTEDBOSS = "Revered";
				UPGRADELIST_SELECTEDINSTANCE = "Ramkahen";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Honored"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Ramkahen");
				UPGRADELIST_SELECTEDBOSS = "Honored";
				UPGRADELIST_SELECTEDINSTANCE = "Ramkahen";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Friendly"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Ramkahen");
				UPGRADELIST_SELECTEDBOSS = "Friendly";
				UPGRADELIST_SELECTEDINSTANCE = "Ramkahen";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Wildhammer Clan Rep
		elseif (level == 3) and (UIDROPDOWNMENU_MENU_VALUE == "Wildhammer Clan") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Exalted"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Wildhammer Clan");
				UPGRADELIST_SELECTEDBOSS = "Exalted";
				UPGRADELIST_SELECTEDINSTANCE = "Wildhammer Clan";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Revered"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Wildhammer Clan");
				UPGRADELIST_SELECTEDBOSS = "Revered";
				UPGRADELIST_SELECTEDINSTANCE = "Wildhammer Clan";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Honored"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Wildhammer Clan");
				UPGRADELIST_SELECTEDBOSS = "Honored";
				UPGRADELIST_SELECTEDINSTANCE = "Wildhammer Clan";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Friendly"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Wildhammer Clan");
				UPGRADELIST_SELECTEDBOSS = "Friendly";
				UPGRADELIST_SELECTEDINSTANCE = "Wildhammer Clan";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Dragonmaw Clan Rep
		elseif (level == 3) and (UIDROPDOWNMENU_MENU_VALUE == "Dragonmaw Clan") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Exalted"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Dragonmaw Clan");
				UPGRADELIST_SELECTEDBOSS = "Exalted";
				UPGRADELIST_SELECTEDINSTANCE = "Dragonmaw Clan";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Revered"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Dragonmaw Clan");
				UPGRADELIST_SELECTEDBOSS = "Revered";
				UPGRADELIST_SELECTEDINSTANCE = "Dragonmaw Clan";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Honored"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Dragonmaw Clan");
				UPGRADELIST_SELECTEDBOSS = "Honored";
				UPGRADELIST_SELECTEDINSTANCE = "Dragonmaw Clan";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Friendly"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Dragonmaw Clan");
				UPGRADELIST_SELECTEDBOSS = "Friendly";
				UPGRADELIST_SELECTEDINSTANCE = "Dragonmaw Clan";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Baradin's Wardens Rep
		elseif (level == 3) and (UIDROPDOWNMENU_MENU_VALUE == "Baradin's Wardens") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Exalted"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Baradin's Wardens");
				UPGRADELIST_SELECTEDBOSS = "Exalted";
				UPGRADELIST_SELECTEDINSTANCE = "Baradin's Wardens";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Revered"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Baradin's Wardens");
				UPGRADELIST_SELECTEDBOSS = "Revered";
				UPGRADELIST_SELECTEDINSTANCE = "Baradin's Wardens";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Honored"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Baradin's Wardens");
				UPGRADELIST_SELECTEDBOSS = "Honored";
				UPGRADELIST_SELECTEDINSTANCE = "Baradin's Wardens";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Friendly"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Baradin's Wardens");
				UPGRADELIST_SELECTEDBOSS = "Friendly";
				UPGRADELIST_SELECTEDINSTANCE = "Baradin's Wardens";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Hellscream's Reach Rep
		elseif (level == 3) and (UIDROPDOWNMENU_MENU_VALUE == "Hellscream's Reach") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Exalted"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Hellscream's Reach");
				UPGRADELIST_SELECTEDBOSS = "Exalted";
				UPGRADELIST_SELECTEDINSTANCE = "Hellscream's Reach";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Revered"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Hellscream's Reach");
				UPGRADELIST_SELECTEDBOSS = "Revered";
				UPGRADELIST_SELECTEDINSTANCE = "Hellscream's Reach";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Honored"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Hellscream's Reach");
				UPGRADELIST_SELECTEDBOSS = "Honored";
				UPGRADELIST_SELECTEDINSTANCE = "Hellscream's Reach";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Friendly"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Hellscream's Reach");
				UPGRADELIST_SELECTEDBOSS = "Friendly";
				UPGRADELIST_SELECTEDINSTANCE = "Hellscream's Reach";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Guild Rep
		elseif (level == 3) and (UIDROPDOWNMENU_MENU_VALUE == GetGuildInfo("player")) then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Exalted"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, GetGuildInfo("player"));
				UPGRADELIST_SELECTEDBOSS = "Exalted";
				UPGRADELIST_SELECTEDINSTANCE = GetGuildInfo("player");
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Revered"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, GetGuildInfo("player"));
				UPGRADELIST_SELECTEDBOSS = "Revered";
				UPGRADELIST_SELECTEDINSTANCE = GetGuildInfo("player");
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Honored"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, GetGuildInfo("player"));
				UPGRADELIST_SELECTEDBOSS = "Honored";
				UPGRADELIST_SELECTEDINSTANCE = GetGuildInfo("player");
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Friendly"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, GetGuildInfo("player"));
				UPGRADELIST_SELECTEDBOSS = "Friendly";
				UPGRADELIST_SELECTEDINSTANCE = GetGuildInfo("player");
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		elseif (level == 3) and (UIDROPDOWNMENU_MENU_VALUE == "Gear Token") then
			local localizedClass, englishClass = UnitClass("player");
			local info = UIDropDownMenu_CreateInfo()
			if (englishClass == "DEATHKNIGHT") or (englishClass == "DRUID") or (englishClass == "MAGE") or (englishClass == "ROGUE") then
				info.text = "Crown of the Forlorn Vanquisher"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Crown of the Forlorn Vanquisher");
					UPGRADELIST_SELECTEDBOSS = "\"Essence of the Forlorn\" token";
					UPGRADELIST_SELECTEDINSTANCE = "Crown of the Forlorn Vanquisher";
					UPGRADELIST_SELECTEDDIFFICULTY = "Tier 11 Heroic";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Shoulders of the Forlorn Vanquisher"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Shoulders of the Forlorn Vanquisher");
					UPGRADELIST_SELECTEDBOSS = "\"Essence of the Forlorn\" token";
					UPGRADELIST_SELECTEDINSTANCE = "Shoulders of the Forlorn Vanquisher";
					UPGRADELIST_SELECTEDDIFFICULTY = "Tier 11 Heroic";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Chest of the Forlorn Vanquisher"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Chest of the Forlorn Vanquisher");
					UPGRADELIST_SELECTEDBOSS = "Halfus Wyrmbreaker or \"Essence of the Forlorn\" token";
					UPGRADELIST_SELECTEDINSTANCE = "Chest of the Forlorn Vanquisher";
					UPGRADELIST_SELECTEDDIFFICULTY = "Tier 11 Heroic";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Gauntlets of the Forlorn Vanquisher"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Gauntlets of the Forlorn Vanquisher");
					UPGRADELIST_SELECTEDBOSS = "\"Essence of the Forlorn\" token";
					UPGRADELIST_SELECTEDINSTANCE = "Gauntlets of the Forlorn Vanquisher";
					UPGRADELIST_SELECTEDDIFFICULTY = "Tier 11 Heroic";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Leggings of the Forlorn Vanquisher"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Leggings of the Forlorn Vanquisher");
					UPGRADELIST_SELECTEDBOSS = "Maloriak or \"Essence of the Forlorn\" token";
					UPGRADELIST_SELECTEDINSTANCE = "Leggings of the Forlorn Vanquisher";
					UPGRADELIST_SELECTEDDIFFICULTY = "Tier 11 Heroic";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Helm of the Forlorn Vanquisher"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Helm of the Forlorn Vanquisher");
					UPGRADELIST_SELECTEDBOSS = "Nefarian";
					UPGRADELIST_SELECTEDINSTANCE = "Helm of the Forlorn Vanquisher";
					UPGRADELIST_SELECTEDDIFFICULTY = "Tier 11";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Mantle of the Forlorn Vanquisher"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Mantle of the Forlorn Vanquisher");
					UPGRADELIST_SELECTEDBOSS = "Cho'gall";
					UPGRADELIST_SELECTEDINSTANCE = "Mantle of the Forlorn Vanquisher";
					UPGRADELIST_SELECTEDDIFFICULTY = "Tier 11";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
			elseif (englishClass == "PALADIN") or (englishClass == "PRIEST") or (englishClass == "WARLOCK") then
				info.text = "Crown of the Forlorn Conqueror"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Crown of the Forlorn Conqueror");
					UPGRADELIST_SELECTEDBOSS = "\"Essence of the Forlorn\" token";
					UPGRADELIST_SELECTEDINSTANCE = "Crown of the Forlorn Conqueror";
					UPGRADELIST_SELECTEDDIFFICULTY = "Tier 11 Heroic";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Shoulders of the Forlorn Conqueror"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Shoulders of the Forlorn Conqueror");
					UPGRADELIST_SELECTEDBOSS = "\"Essence of the Forlorn\" token";
					UPGRADELIST_SELECTEDINSTANCE = "Shoulders of the Forlorn Conqueror";
					UPGRADELIST_SELECTEDDIFFICULTY = "Tier 11 Heroic";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Chest of the Forlorn Conqueror"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Chest of the Forlorn Conqueror");
					UPGRADELIST_SELECTEDBOSS = "Halfus Wyrmbreaker or \"Essence of the Forlorn\" token";
					UPGRADELIST_SELECTEDINSTANCE = "Chest of the Forlorn Conqueror";
					UPGRADELIST_SELECTEDDIFFICULTY = "Tier 11 Heroic";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Gauntlets of the Forlorn Conqueror"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Gauntlets of the Forlorn Conqueror");
					UPGRADELIST_SELECTEDBOSS = "\"Essence of the Forlorn\" token";
					UPGRADELIST_SELECTEDINSTANCE = "Gauntlets of the Forlorn Conqueror";
					UPGRADELIST_SELECTEDDIFFICULTY = "Tier 11 Heroic";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Leggings of the Forlorn Conqueror"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Leggings of the Forlorn Conqueror");
					UPGRADELIST_SELECTEDBOSS = "Maloriak or \"Essence of the Forlorn\" token";
					UPGRADELIST_SELECTEDINSTANCE = "Leggings of the Forlorn Conqueror";
					UPGRADELIST_SELECTEDDIFFICULTY = "Tier 11 Heroic";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Helm of the Forlorn Conqueror"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Helm of the Forlorn Conqueror");
					UPGRADELIST_SELECTEDBOSS = "Nefarian";
					UPGRADELIST_SELECTEDINSTANCE = "Helm of the Forlorn Conqueror";
					UPGRADELIST_SELECTEDDIFFICULTY = "Tier 11";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Mantle of the Forlorn Conqueror"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Mantle of the Forlorn Conqueror");
					UPGRADELIST_SELECTEDBOSS = "Cho'gall";
					UPGRADELIST_SELECTEDINSTANCE = "Mantle of the Forlorn Conqueror";
					UPGRADELIST_SELECTEDDIFFICULTY = "Tier 11";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
			elseif (englishClass == "HUNTER") or (englishClass == "SHAMAN") or (englishClass == "WARRIOR") then
				info.text = "Crown of the Forlorn Protector"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Crown of the Forlorn Protector");
					UPGRADELIST_SELECTEDBOSS = "\"Essence of the Forlorn\" token";
					UPGRADELIST_SELECTEDINSTANCE = "Crown of the Forlorn Protector";
					UPGRADELIST_SELECTEDDIFFICULTY = "Tier 11 Heroic";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Shoulders of the Forlorn Protector"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Shoulders of the Forlorn Protector");
					UPGRADELIST_SELECTEDBOSS = "\"Essence of the Forlorn\" token";
					UPGRADELIST_SELECTEDINSTANCE = "Shoulders of the Forlorn Protector";
					UPGRADELIST_SELECTEDDIFFICULTY = "Tier 11 Heroic";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Chest of the Forlorn Protector"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Chest of the Forlorn Protector");
					UPGRADELIST_SELECTEDBOSS = "Halfus Wyrmbreaker or \"Essence of the Forlorn\" token";
					UPGRADELIST_SELECTEDINSTANCE = "Chest of the Forlorn Protector";
					UPGRADELIST_SELECTEDDIFFICULTY = "Tier 11 Heroic";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Gauntlets of the Forlorn Protector"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Gauntlets of the Forlorn Protector");
					UPGRADELIST_SELECTEDBOSS = "\"Essence of the Forlorn\" token";
					UPGRADELIST_SELECTEDINSTANCE = "Gauntlets of the Forlorn Protector";
					UPGRADELIST_SELECTEDDIFFICULTY = "Tier 11 Heroic";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Leggings of the Forlorn Protector"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Leggings of the Forlorn Protector");
					UPGRADELIST_SELECTEDBOSS = "Maloriak or \"Essence of the Forlorn\" token";
					UPGRADELIST_SELECTEDINSTANCE = "Leggings of the Forlorn Protector";
					UPGRADELIST_SELECTEDDIFFICULTY = "Tier 11 Heroic";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Helm of the Forlorn Protector"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Helm of the Forlorn Protector");
					UPGRADELIST_SELECTEDBOSS = "Nefarian";
					UPGRADELIST_SELECTEDINSTANCE = "Helm of the Forlorn Protector";
					UPGRADELIST_SELECTEDDIFFICULTY = "Tier 11";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Mantle of the Forlorn Protector"
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, "Mantle of the Forlorn Protector");
					UPGRADELIST_SELECTEDBOSS = "Cho'gall";
					UPGRADELIST_SELECTEDINSTANCE = "Mantle of the Forlorn Protector";
					UPGRADELIST_SELECTEDDIFFICULTY = "Tier 11";
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
			else
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("ERROR: Unable to determine your class.");
			end
				
		--Normal Baradin Hold Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Baradin Hold Normal") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Argaloth"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Argaloth");
				UPGRADELIST_SELECTEDBOSS = "Argaloth";
				UPGRADELIST_SELECTEDINSTANCE = "Baradin Hold";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "(Trash Drop)"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "(Trash Drop)");
				UPGRADELIST_SELECTEDBOSS = "(Trash Drop)";
				UPGRADELIST_SELECTEDINSTANCE = "Baradin Hold";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Heroic Baradin Hold Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Baradin Hold Heroic") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Argaloth"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Argaloth");
				UPGRADELIST_SELECTEDBOSS = "Argaloth";
				UPGRADELIST_SELECTEDINSTANCE = "Baradin Hold";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "(Trash Drop)"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "(Trash Drop)");
				UPGRADELIST_SELECTEDBOSS = "(Trash Drop)";
				UPGRADELIST_SELECTEDINSTANCE = "Baradin Hold";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Normal Bastion of Twilight Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Bastion of Twilight Normal") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Halfus Wyrmbreaker"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Halfus Wyrmbreaker");
				UPGRADELIST_SELECTEDBOSS = "Hyalfus Wyrmbreaker";
				UPGRADELIST_SELECTEDINSTANCE = "Bastion of Twilight";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Valiona & Theralion"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Valiona & Theralion");
				UPGRADELIST_SELECTEDBOSS = "Valiona & Theralion";
				UPGRADELIST_SELECTEDINSTANCE = "Bastion of Twilight";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Ascendent Council"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Ascendent Council");
				UPGRADELIST_SELECTEDBOSS = "Ascendent Council";
				UPGRADELIST_SELECTEDINSTANCE = "Bastion of Twilight";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Cho'gall"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Cho'gall");
				UPGRADELIST_SELECTEDBOSS = "Cho'gall";
				UPGRADELIST_SELECTEDINSTANCE = "Bastion of Twilight";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "(Trash Drop)"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "(Trash Drop)");
				UPGRADELIST_SELECTEDBOSS = "(Trash Drop)";
				UPGRADELIST_SELECTEDINSTANCE = "Bastion of Twilight";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
		
		--Heroic Bastion of Twilight Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Bastion of Twilight Heroic") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Halfus Wyrmbreaker"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Halfus Wyrmbreaker");
				UPGRADELIST_SELECTEDBOSS = "Hyalfus Wyrmbreaker";
				UPGRADELIST_SELECTEDINSTANCE = "Bastion of Twilight";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Valiona & Theralion"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Valiona & Theralion");
				UPGRADELIST_SELECTEDBOSS = "Valiona & Theralion";
				UPGRADELIST_SELECTEDINSTANCE = "Bastion of Twilight";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Ascendent Council"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Ascendent Council");
				UPGRADELIST_SELECTEDBOSS = "Ascendent Council";
				UPGRADELIST_SELECTEDINSTANCE = "Bastion of Twilight";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Cho'gall"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Cho'gall");
				UPGRADELIST_SELECTEDBOSS = "Cho'gall";
				UPGRADELIST_SELECTEDINSTANCE = "Bastion of Twilight";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Sinestra"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Sinestra");
				UPGRADELIST_SELECTEDBOSS = "Sinestra";
				UPGRADELIST_SELECTEDINSTANCE = "Bastion of Twilight";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "(Trash Drop)"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "(Trash Drop)");
				UPGRADELIST_SELECTEDBOSS = "(Trash Drop)";
				UPGRADELIST_SELECTEDINSTANCE = "Bastion of Twilight";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Normal Blackwing Descent Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Blackwing Descent Normal") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Omnotron Defense System"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Omnotron Defense System");
				UPGRADELIST_SELECTEDBOSS = "Omnotron Defense System";
				UPGRADELIST_SELECTEDINSTANCE = "Blackwing Descent";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Magmaw"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Magmaw");
				UPGRADELIST_SELECTEDBOSS = "Magmaw";
				UPGRADELIST_SELECTEDINSTANCE = "Blackwing Descent";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Maloriak"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Maloriak");
				UPGRADELIST_SELECTEDBOSS = "Maloriak";
				UPGRADELIST_SELECTEDINSTANCE = "Blackwing Descent";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Atramedes"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Atramedes");
				UPGRADELIST_SELECTEDBOSS = "Atramedes";
				UPGRADELIST_SELECTEDINSTANCE = "Blackwing Descent";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Chimaeron"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Chimaeron");
				UPGRADELIST_SELECTEDBOSS = "Chimaeron";
				UPGRADELIST_SELECTEDINSTANCE = "Blackwing Descent";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Nefarian"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Nefarian");
				UPGRADELIST_SELECTEDBOSS = "Nefarian";
				UPGRADELIST_SELECTEDINSTANCE = "Blackwing Descent";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "(Trash Drop)"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "(Trash Drop)");
				UPGRADELIST_SELECTEDBOSS = "(Trash Drop)";
				UPGRADELIST_SELECTEDINSTANCE = "Blackwing Descent";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			--Heroic Blackwing Descent Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Blackwing Descent Heroic") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Omnotron Defense System"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Omnotron Defense System");
				UPGRADELIST_SELECTEDBOSS = "Omnotron Defense System";
				UPGRADELIST_SELECTEDINSTANCE = "Blackwing Descent";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Magmaw"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Magmaw");
				UPGRADELIST_SELECTEDBOSS = "Magmaw";
				UPGRADELIST_SELECTEDINSTANCE = "Blackwing Descent";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Maloriak"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Maloriak");
				UPGRADELIST_SELECTEDBOSS = "Maloriak";
				UPGRADELIST_SELECTEDINSTANCE = "Blackwing Descent";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Atramedes"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Atramedes");
				UPGRADELIST_SELECTEDBOSS = "Atramedes";
				UPGRADELIST_SELECTEDINSTANCE = "Blackwing Descent";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Chimaeron"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Chimaeron");
				UPGRADELIST_SELECTEDBOSS = "Chimaeron";
				UPGRADELIST_SELECTEDINSTANCE = "Blackwing Descent";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Nefarian"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Nefarian");
				UPGRADELIST_SELECTEDBOSS = "Nefarian";
				UPGRADELIST_SELECTEDINSTANCE = "Blackwing Descent";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "(Trash Drop)"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "(Trash Drop)");
				UPGRADELIST_SELECTEDBOSS = "(Trash Drop)";
				UPGRADELIST_SELECTEDINSTANCE = "Blackwing Descent";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
		
		--Normal Throne of the Four Winds Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Throne of the Four Winds Normal") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Conclave of Wind"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Conclave of Wind");
				UPGRADELIST_SELECTEDBOSS = "Conclave of Wind";
				UPGRADELIST_SELECTEDINSTANCE = "Throne of the Four Winds";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Al'Akir"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Al'Akir");
				UPGRADELIST_SELECTEDBOSS = "Al'Akir";
				UPGRADELIST_SELECTEDINSTANCE = "Throne of the Four Winds";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Heroic Throne of the Four Winds Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Throne of the Four Winds Heroic") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Conclave of Wind"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Conclave of Wind");
				UPGRADELIST_SELECTEDBOSS = "Conclave of Wind";
				UPGRADELIST_SELECTEDINSTANCE = "Throne of the Four Winds";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Al'Akir"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Al'Akir");
				UPGRADELIST_SELECTEDBOSS = "Al'Akir";
				UPGRADELIST_SELECTEDINSTANCE = "Throne of the Four Winds";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Heroic Throne of Tides Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Throne of the Tides Heroic") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Lady Naz'jar"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Lady Naz'jar");
				UPGRADELIST_SELECTEDBOSS = "Lady Naz'jar";
				UPGRADELIST_SELECTEDINSTANCE = "Throne of the Tides";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Commander Ulthok"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Commander Ulthok");
				UPGRADELIST_SELECTEDBOSS = "Commander Ulthok";
				UPGRADELIST_SELECTEDINSTANCE = "Throne of the Tides";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Mindbender Ghur'sha"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Mindbender Ghur'sha");
				UPGRADELIST_SELECTEDBOSS = "Mindbender Ghur'sha";
				UPGRADELIST_SELECTEDINSTANCE = "Throne of the Tides";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Ozumat"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Ozumat");
				UPGRADELIST_SELECTEDBOSS = "Ozumat";
				UPGRADELIST_SELECTEDINSTANCE = "Throne of the Tides";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Heroic Blackrock Caverns Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Blackrock Caverns Heroic") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Rom'ogg Bonecrusher"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Rom'ogg Bonecrusher");
				UPGRADELIST_SELECTEDBOSS = "Rom'ogg Bonecrusher";
				UPGRADELIST_SELECTEDINSTANCE = "Blackrock Caverns";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Corla, Herald of Twilight"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Corla, Herald of Twilight");
				UPGRADELIST_SELECTEDBOSS = "Corla, Herald of Twilight";
				UPGRADELIST_SELECTEDINSTANCE = "Blackrock Caverns";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Karsh Steelbender"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Karsh Steelbender");
				UPGRADELIST_SELECTEDBOSS = "Karsh Steelbender";
				UPGRADELIST_SELECTEDINSTANCE = "Blackrock Caverns";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Beauty"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Beauty");
				UPGRADELIST_SELECTEDBOSS = "Beauty";
				UPGRADELIST_SELECTEDINSTANCE = "Blackrock Caverns";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Ascendant Lord Obsidius"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Ascendant Lord Obsidius");
				UPGRADELIST_SELECTEDBOSS = "Ascendant Lord Obsidius";
				UPGRADELIST_SELECTEDINSTANCE = "Blackrock Caverns";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Heroic Stonecore Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "The Stonecore Heroic") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Corborus"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Corborus");
				UPGRADELIST_SELECTEDBOSS = "Corborus";
				UPGRADELIST_SELECTEDINSTANCE = "The Stonecore";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Slabhide"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Slabhide");
				UPGRADELIST_SELECTEDBOSS = "Slabhide";
				UPGRADELIST_SELECTEDINSTANCE = "The Stonecore";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Ozruk"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Ozruk");
				UPGRADELIST_SELECTEDBOSS = "Ozruk";
				UPGRADELIST_SELECTEDINSTANCE = "The Stonecore";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "High Priestess Azil"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "High Priestess Azil");
				UPGRADELIST_SELECTEDBOSS = "High Priestess Azil";
				UPGRADELIST_SELECTEDINSTANCE = "The Stonecore";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)

		--Heroic Vortex Pinnacle Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "The Vortex Pinnacle Heroic") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Grand Vizier Ertan"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Grand Vizier Ertan");
				UPGRADELIST_SELECTEDBOSS = "Grand Vizier Ertan";
				UPGRADELIST_SELECTEDINSTANCE = "The Vortex Pinnacle";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Altairus"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Altairus");
				UPGRADELIST_SELECTEDBOSS = "Altairus";
				UPGRADELIST_SELECTEDINSTANCE = "The Vortex Pinnacle";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Asaad"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Asaad");
				UPGRADELIST_SELECTEDBOSS = "Asaad";
				UPGRADELIST_SELECTEDINSTANCE = "The Vortex Pinnacle";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)

		--Heroic Lost City of Tol'vir Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Lost City of Tol'vir Heroic") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "General Husam"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "General Husam");
				UPGRADELIST_SELECTEDBOSS = "General Husam";
				UPGRADELIST_SELECTEDINSTANCE = "Lost City of Tol'vir";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Augh and Lockmaw"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Augh and Lockmaw");
				UPGRADELIST_SELECTEDBOSS = "Augh and Lockmaw";
				UPGRADELIST_SELECTEDINSTANCE = "Lost City of Tol'vir";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "High Prophet Barim"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "High Prophet Barim");
				UPGRADELIST_SELECTEDBOSS = "High Prophet Barim";
				UPGRADELIST_SELECTEDINSTANCE = "Lost City of Tol'vir";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Siamat"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Siamat");
				UPGRADELIST_SELECTEDBOSS = "Siamat";
				UPGRADELIST_SELECTEDINSTANCE = "Lost City of Tol'vir";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Heroic Grim Batol Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Grim Batol Heroic") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "General Umbriss"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "General Umbriss");
				UPGRADELIST_SELECTEDBOSS = "General Umbriss";
				UPGRADELIST_SELECTEDINSTANCE = "Grim Batol";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Forgemaster Throngus"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Forgemaster Throngus");
				UPGRADELIST_SELECTEDBOSS = "Forgemaster Throngus";
				UPGRADELIST_SELECTEDINSTANCE = "Grim Batol";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Drahga Shadowburner"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Drahga Shadowburner");
				UPGRADELIST_SELECTEDBOSS = "Drahga Shadowburner";
				UPGRADELIST_SELECTEDINSTANCE = "Grim Batol";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Erudax"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Erudax");
				UPGRADELIST_SELECTEDBOSS = "Erudax";
				UPGRADELIST_SELECTEDINSTANCE = "Grim Batol";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Heroic Halls of Origination Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Halls of Origination Heroic") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Temple Guardian Anhuur"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Temple Guardian Anhuur");
				UPGRADELIST_SELECTEDBOSS = "Themple Guardian Anhuur";
				UPGRADELIST_SELECTEDINSTANCE = "Halls of Origination";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Earthrager Ptah"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Earthrager Ptah");
				UPGRADELIST_SELECTEDBOSS = "Earthrager Ptah";
				UPGRADELIST_SELECTEDINSTANCE = "Halls of Origination";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Anraphet"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Anraphet");
				UPGRADELIST_SELECTEDBOSS = "Anraphet";
				UPGRADELIST_SELECTEDINSTANCE = "Halls of Origination";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Isiset"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Isiset");
				UPGRADELIST_SELECTEDBOSS = "Isiset";
				UPGRADELIST_SELECTEDINSTANCE = "Halls of Origination";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Ammunae"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Ammunae");
				UPGRADELIST_SELECTEDBOSS = "Ammunae";
				UPGRADELIST_SELECTEDINSTANCE = "Halls of Origination";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Setesh"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Setesh");
				UPGRADELIST_SELECTEDBOSS = "Setesh";
				UPGRADELIST_SELECTEDINSTANCE = "Halls of Origination";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Rajh"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Rajh");
				UPGRADELIST_SELECTEDBOSS = "Rajh";
				UPGRADELIST_SELECTEDINSTANCE = "Halls of Origination";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Heroic Deadmines Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "The Deadmines Heroic") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Glubtok"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Glubtok");
				UPGRADELIST_SELECTEDBOSS = "Glubtok";
				UPGRADELIST_SELECTEDINSTANCE = "The Deadmines";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Helix Gearbreaker"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Helix Gearbreaker");
				UPGRADELIST_SELECTEDBOSS = "Helix Gearbreaker";
				UPGRADELIST_SELECTEDINSTANCE = "The Deadmines";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Foe Reaper 5000"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Foe Reaper 5000");
				UPGRADELIST_SELECTEDBOSS = "Foe Reaper 5000";
				UPGRADELIST_SELECTEDINSTANCE = "The Deadmines";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Admiral Ripsnarl"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Admiral Ripsnarl");
				UPGRADELIST_SELECTEDBOSS = "Admiral Ripsnarl";
				UPGRADELIST_SELECTEDINSTANCE = "The Deadmines";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "\"Captain\" Cookie"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "\"Captain\" Cookie");
				UPGRADELIST_SELECTEDBOSS = "\"Captain\" Cookie";
				UPGRADELIST_SELECTEDINSTANCE = "The Deadmines";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Vanessa VanCleef"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Vanessa VanCleef");
				UPGRADELIST_SELECTEDBOSS = "Vanessa VanCleef";
				UPGRADELIST_SELECTEDINSTANCE = "The Deadmines";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Heroic Shadowfang Keep Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Shadowfang Keep Heroic") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Baron Ashbury"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Baron Ashbury");
				UPGRADELIST_SELECTEDBOSS = "Baron Ashbury";
				UPGRADELIST_SELECTEDINSTANCE = "Shadowfang Keep";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Baron Silverlaine"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Baron Silverlaine");
				UPGRADELIST_SELECTEDBOSS = "Baron Silverlaine";
				UPGRADELIST_SELECTEDINSTANCE = "Shadowfang Keep";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Commander Springvale"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Commander Springvale");
				UPGRADELIST_SELECTEDBOSS = "Commander Springvale";
				UPGRADELIST_SELECTEDINSTANCE = "Shadowfang Keep";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Lord Walden"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Lord Walden");
				UPGRADELIST_SELECTEDBOSS = "Lord Walden";
				UPGRADELIST_SELECTEDINSTANCE = "Shadowfang Keep";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Lord Godfrey"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Lord Godfrey");
				UPGRADELIST_SELECTEDBOSS = "Lord Godfrey";
				UPGRADELIST_SELECTEDINSTANCE = "Shadowfang Keep";
				UPGRADELIST_SELECTEDDIFFICULTY = "Heroic";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Normal Throne of Tides Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Throne of the Tides Normal") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Lady Naz'jar"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Lady Naz'jar");
				UPGRADELIST_SELECTEDBOSS = "Lady Naz'jar";
				UPGRADELIST_SELECTEDINSTANCE = "Throne of the Tides";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Commander Ulthok"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Commander Ulthok");
				UPGRADELIST_SELECTEDBOSS = "Commander Ulthok";
				UPGRADELIST_SELECTEDINSTANCE = "Throne of the Tides";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Mindbender Ghur'sha"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Mindbender Ghur'sha");
				UPGRADELIST_SELECTEDBOSS = "Mindbender Ghur'sha";
				UPGRADELIST_SELECTEDINSTANCE = "Throne of the Tides";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Ozumat"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Ozumat");
				UPGRADELIST_SELECTEDBOSS = "Ozumat";
				UPGRADELIST_SELECTEDINSTANCE = "Throne of the Tides";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Normal Blackrock Caverns Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Blackrock Caverns Normal") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Rom'ogg Bonecrusher"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Rom'ogg Bonecrusher");
				UPGRADELIST_SELECTEDBOSS = "Rom'ogg Bonecrusher";
				UPGRADELIST_SELECTEDINSTANCE = "Blackrock Caverns";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Corla, Herald of Twilight"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Corla, Herald of Twilight");
				UPGRADELIST_SELECTEDBOSS = "Corla, Herald of Twilight";
				UPGRADELIST_SELECTEDINSTANCE = "Blackrock Caverns";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Karsh Steelbender"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Karsh Steelbender");
				UPGRADELIST_SELECTEDBOSS = "Karsh Steelbender";
				UPGRADELIST_SELECTEDINSTANCE = "Blackrock Caverns";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Beauty"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Beauty");
				UPGRADELIST_SELECTEDBOSS = "Beauty";
				UPGRADELIST_SELECTEDINSTANCE = "Blackrock Caverns";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Ascendant Lord Obsidius"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Ascendant Lord Obsidius");
				UPGRADELIST_SELECTEDBOSS = "Ascendant Lord Obsidius";
				UPGRADELIST_SELECTEDINSTANCE = "Blackrock Caverns";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Normal Stonecore Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "The Stonecore Normal") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Corborus"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Corborus");
				UPGRADELIST_SELECTEDBOSS = "Corborus";
				UPGRADELIST_SELECTEDINSTANCE = "The Stonecore";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Slabhide"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Slabhide");
				UPGRADELIST_SELECTEDBOSS = "Slabhide";
				UPGRADELIST_SELECTEDINSTANCE = "The Stonecore";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Ozruk"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Ozruk");
				UPGRADELIST_SELECTEDBOSS = "Ozruk";
				UPGRADELIST_SELECTEDINSTANCE = "The Stonecore";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "High Priestess Azil"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "High Priestess Azil");
				UPGRADELIST_SELECTEDBOSS = "High Priestess Azil";
				UPGRADELIST_SELECTEDINSTANCE = "The Stonecore";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)

		--Normal Vortex Pinnacle Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "The Vortex Pinnacle Normal") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Grand Vizier Ertan"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Grand Vizier Ertan");
				UPGRADELIST_SELECTEDBOSS = "Grand Vizier Ertan";
				UPGRADELIST_SELECTEDINSTANCE = "The Vortex Pinnacle";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Altairus"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Altairus");
				UPGRADELIST_SELECTEDBOSS = "Altairus";
				UPGRADELIST_SELECTEDINSTANCE = "The Vortex Pinnacle";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Asaad"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Asaad");
				UPGRADELIST_SELECTEDBOSS = "Asaad";
				UPGRADELIST_SELECTEDINSTANCE = "The Vortex Pinnacle";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)

		--Normal Lost City of Tol'vir Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Lost City of Tol'vir Normal") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "General Husam"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "General Husam");
				UPGRADELIST_SELECTEDBOSS = "General Husam";
				UPGRADELIST_SELECTEDINSTANCE = "Lost City of Tol'vir";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Augh and Lockmaw"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Augh and Lockmaw");
				UPGRADELIST_SELECTEDBOSS = "Augh and Lockmaw";
				UPGRADELIST_SELECTEDINSTANCE = "Lost City of Tol'vir";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "High Prophet Barim"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "High Prophet Barim");
				UPGRADELIST_SELECTEDBOSS = "High Prophet Barim";
				UPGRADELIST_SELECTEDINSTANCE = "Lost City of Tol'vir";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Siamat"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Siamat");
				UPGRADELIST_SELECTEDBOSS = "Siamat";
				UPGRADELIST_SELECTEDINSTANCE = "Lost City of Tol'vir";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Normal Grim Batol Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Grim Batol Normal") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "General Umbriss"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "General Umbriss");
				UPGRADELIST_SELECTEDBOSS = "General Umbriss";
				UPGRADELIST_SELECTEDINSTANCE = "Grim Batol";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Forgemaster Throngus"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Forgemaster Throngus");
				UPGRADELIST_SELECTEDBOSS = "Forgemaster Throngus";
				UPGRADELIST_SELECTEDINSTANCE = "Grim Batol";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Drahga Shadowburner"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Drahga Shadowburner");
				UPGRADELIST_SELECTEDBOSS = "Drahga Shadowburner";
				UPGRADELIST_SELECTEDINSTANCE = "Grim Batol";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Erudax"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Erudax");
				UPGRADELIST_SELECTEDBOSS = "Erudax";
				UPGRADELIST_SELECTEDINSTANCE = "Grim Batol";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
		--Normal Halls of Origination Bosses
		elseif (level == 4) and (UIDROPDOWNMENU_MENU_VALUE == "Halls of Origination Normal") then
			local info = UIDropDownMenu_CreateInfo()
			
			info.text = "Temple Guardian Anhuur"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Temple Guardian Anhuur");
				UPGRADELIST_SELECTEDBOSS = "Themple Guardian Anhuur";
				UPGRADELIST_SELECTEDINSTANCE = "Halls of Origination";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Earthrager Ptah"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Earthrager Ptah");
				UPGRADELIST_SELECTEDBOSS = "Earthrager Ptah";
				UPGRADELIST_SELECTEDINSTANCE = "Halls of Origination";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Anraphet"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Anraphet");
				UPGRADELIST_SELECTEDBOSS = "Anraphet";
				UPGRADELIST_SELECTEDINSTANCE = "Halls of Origination";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Isiset"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Isiset");
				UPGRADELIST_SELECTEDBOSS = "Isiset";
				UPGRADELIST_SELECTEDINSTANCE = "Halls of Origination";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Ammunae"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Ammunae");
				UPGRADELIST_SELECTEDBOSS = "Ammunae";
				UPGRADELIST_SELECTEDINSTANCE = "Halls of Origination";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Setesh"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Setesh");
				UPGRADELIST_SELECTEDBOSS = "Setesh";
				UPGRADELIST_SELECTEDINSTANCE = "Halls of Origination";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Rajh"
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Rajh");
				UPGRADELIST_SELECTEDBOSS = "Rajh";
				UPGRADELIST_SELECTEDINSTANCE = "Halls of Origination";
				UPGRADELIST_SELECTEDDIFFICULTY = "Normal";
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
		end
	end

	
	function DropDown_DropDownOnLoad(self)
		UIDropDownMenu_Initialize(self, DropDown_InitializeDropDown)
	end

	function DropDown_ButtonOnClick(self, button, down)
		local name = self:GetName()
		ToggleDropDownMenu(1, nil, DropDown_DropDown, name, 0, 0)
	end
	
	UIDropDownMenu_Initialize(DropDown_Button, DropDown_InitializeDropDown)
	UIDropDownMenu_SetWidth(DropDown_Button, 175);
	UIDropDownMenu_SetButtonWidth(DropDown_Button, 175)
	UIDropDownMenu_SetSelectedID(DropDown_Button, 0)
	UIDropDownMenu_JustifyText(DropDown_Button, "CENTER")
	UIDropDownMenu_SetText(DropDown_Button, "Location:")

	local DropDownHeading = CreateFrame('Frame', "DropDownHeading", OptionsFrame);
	NoteFont = DropDownHeading:CreateFontString("DropDownHeading", "ARTWORK", "GameFontNormalSmallLeft");
	NoteFont:SetText("Select Item Location:");
	NoteFont:SetPoint("BOTTOM", DropDown_Button, "TOP");
	NoteFont:SetWidth(NoteFont:GetStringWidth());
	NoteFont:SetHeight(NoteFont:GetStringHeight());	
	
	--Creation of the Note Entry Box
	local NoteEntryBox = CreateFrame('EditBox', "NoteEntryBox", OptionsFrame, "InputBoxTemplate");
	NoteEntryBox:SetPoint("TOP", DropDown_Button, "BOTTOM", 0, -20);
	NoteEntryBox:SetAutoFocus(false);
	NoteEntryBox:SetWidth(250);
    NoteEntryBox:SetHeight(24);
	NoteEntryBox:SetMaxLetters(28);
	
	local NoteEntryBoxHeading = CreateFrame('Frame', "NoteEntryBoxHeading", OptionsFrame);
	NoteFont = NoteEntryBoxHeading:CreateFontString("NoteHeading", "ARTWORK", "GameFontNormalSmallLeft");
	NoteFont:SetText("Enter an optional note:");
	NoteFont:SetPoint("BOTTOM", NoteEntryBox, "TOP");
	NoteFont:SetWidth(NoteFont:GetStringWidth());
	NoteFont:SetHeight(NoteFont:GetStringHeight());	
	
	--Primary Spec Selector Radio Button
	local PrimarySpecRadioButton = CreateFrame('CheckButton', "PrimarySpecRadioButton", OptionsFrame, "UIRadioButtonTemplate");
	PrimarySpecRadioButton:SetHeight(20);
	PrimarySpecRadioButton:SetWidth(20);
	PrimarySpecRadioButton:SetChecked(true);
	PrimarySpecRadioButton:SetPoint("TOP", NoteEntryBox, "BOTTOM", -95, -25);
	_G[PrimarySpecRadioButton:GetName() .. "Text"]:SetText("Primary Spec");
	PrimarySpecRadioButton:SetScript("OnClick", function (self, button, down)
		if GetNumTalentGroups("player") == 1 then
			SecondarySpecRadioButton:Disable();
			PrimarySpecRadioButton:SetChecked(true);
		else
			SecondarySpecRadioButton:SetChecked(false);
		end
	PrimarySpecRadioButton:SetChecked(true);
	end);
	
	--Secondary Spec Selector Radio Button
	local SecondarySpecRadioButton = CreateFrame('CheckButton', "SecondarySpecRadioButton", OptionsFrame, "UIRadioButtonTemplate");
	SecondarySpecRadioButton:SetHeight(20);
	SecondarySpecRadioButton:SetWidth(20);
	SecondarySpecRadioButton:SetChecked(false);
	SecondarySpecRadioButton:SetPoint("TOP", NoteEntryBox, "BOTTOM", 20, -25);
	_G[SecondarySpecRadioButton:GetName() .. "Text"]:SetText("Secondary Spec");
	if GetNumTalentGroups("player") == 1 then
		_G[SecondarySpecRadioButton:GetName() .. "Text"]:SetTextColor(0.5, 0.5, 0.5);
		SecondarySpecRadioButton:Disable();
	end
	SecondarySpecRadioButton:SetScript("OnClick", function (self, button, down)
		SecondarySpecRadioButton:SetChecked(true);
		PrimarySpecRadioButton:SetChecked(false);
	end);
	
	local SpecEntryBoxHeading = CreateFrame('Frame', "SpecEntryBoxHeading", OptionsFrame);
	SpecFont = SpecEntryBoxHeading:CreateFontString("SpecHeading", "ARTWORK", "GameFontNormalSmallLeft");
	SpecFont:SetText("Select which spec to which you would like to add this item:");
	SpecFont:SetPoint("BOTTOM", NoteEntryBox, "TOP", 0, -47);
	SpecFont:SetWidth(SpecFont:GetStringWidth());
	SpecFont:SetHeight(SpecFont:GetStringHeight());	
	
	--AddItemLocation
	local priorityfield = CreateFrame('EditBox', "priorityfield", OptionsFrame, "InputBoxTemplate");
	priorityfield:SetPoint("TOP", ItemEntryBox, "BOTTOM", 0, -180);
	priorityfield:SetAutoFocus(false);
	priorityfield:SetWidth(25);
	priorityfield:SetHeight(24);
	
	local PriorityBoxHeading = CreateFrame('Frame', "PriorityBoxHeading", OptionsFrame);
	PriorityFont = PriorityBoxHeading:CreateFontString("SpecHeading", "ARTWORK", "GameFontNormalSmallLeft");
	PriorityFont:SetText("Enter the priority number for this item OR \nleave it blank to add the item to bottom of the list:");
	PriorityFont:SetJustifyH("CENTER");
	PriorityFont:SetPoint("BOTTOM", priorityfield, "TOP", 0, 5);
	PriorityFont:SetWidth(PriorityFont:GetStringWidth());
	PriorityFont:SetHeight(PriorityFont:GetStringHeight());	
	
	
	--"Add" button
	local AddButton = CreateFrame('Button', "AddButton", OptionsFrame, "UIPanelButtonTemplate");
	AddButton:SetPoint("TOP", priorityfield, "BOTTOM", 0, -5);
	AddButton:SetWidth(100);
    AddButton:SetHeight(24);
	AddButton:SetText("Add Item");
	AddButton:SetScript("OnClick", function (self, button, down)
		local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(ItemEntryBox:GetText());
		UpgradeList_wait(.5, AddItem, ItemEntryBox, tableUL, PrimarySpecRadioButton, SecondarySpecRadioButton, ViewPrimarySpec, ViewSecondarySpec, UpgradeListMainFrame, priorityfield, statusbarfont, NoteEntryBox);
	end);
	
	--Moving heading text
	MovingHeading = CreateFrame('Frame', "MovingHeading", OptionsFrame);
	MovingHeadingFont = MovingHeading:CreateFontString("MovingHeading", "ARTWORK", "GameFontNormalSmallLeft");
	MovingHeadingFont:SetText("In the currently selected tab, move item #:");
	MovingHeadingFont:SetPoint("BOTTOM", ItemEntryBox, "TOP", -275, 0);
	MovingHeadingFont:SetWidth(MovingHeadingFont:GetStringWidth());
	MovingHeadingFont:SetHeight(MovingHeadingFont:GetStringHeight());
	
	--"From" field for moving items
	local fromfield = CreateFrame('EditBox', "fromfield", OptionsFrame, "InputBoxTemplate");
	fromfield:SetPoint("TOP", MovingHeadingFont, "BOTTOM", -30, 0);
	fromfield:SetAutoFocus(false);
	fromfield:SetWidth(25);
	fromfield:SetHeight(24);
	
	--"To" field for moving items
	local tofield = CreateFrame('EditBox', "tofield", OptionsFrame, "InputBoxTemplate");
	tofield:SetPoint("LEFT", fromfield, "RIGHT", 20, 0);
	tofield:SetAutoFocus(false);
	tofield:SetWidth(25);
	tofield:SetHeight(24);
	
	--"To" between the To and From fields
	local to = CreateFrame('Frame', "To", OptionsFrame);
	toheadingfont = to:CreateFontString("to", "ARTWORK", "GameFontNormalSmallLeft");
	toheadingfont:SetText("to");
	toheadingfont:SetPoint("LEFT", fromfield, "RIGHT", 2, 0);
	
	--"Move Item" button
	local MoveButton = CreateFrame('Button', "MoveButton", OptionsFrame, "UIPanelButtonTemplate");
	MoveButton:SetPoint("TOP", toheadingfont, "BOTTOM", 0, -10);
	MoveButton:SetWidth(100);
    MoveButton:SetHeight(24);
	MoveButton:SetText("Move Item");
	MoveButton:SetScript("OnClick", function (self, button, down)
		MoveItem(fromfield, tofield, UpgradeListMainFrame, tableUL);
	end);
	
	--"Delete item" heading
	DeletingHeading = CreateFrame('Frame', "DeletingHeading", OptionsFrame);
	DeletingHeadingFont = DeletingHeading:CreateFontString("DeletingHeading", "ARTWORK", "GameFontNormalSmallLeft");
	DeletingHeadingFont:SetText("In the currently selected tab, delete item #:");
	DeletingHeadingFont:SetPoint("BOTTOM", ItemEntryBox, "TOP", 275, 0);
	DeletingHeadingFont:SetWidth(DeletingHeadingFont:GetStringWidth());
	DeletingHeadingFont:SetHeight(DeletingHeadingFont:GetStringHeight());
	
	--"Delete Item" button
	local DeleteButton = CreateFrame('Button', "DeleteButton", OptionsFrame, "UIPanelButtonTemplate");
	DeleteButton:SetPoint("TOP", DeletingHeadingFont, "BOTTOM", 0, -25);
	DeleteButton:SetWidth(100);
    DeleteButton:SetHeight(24);
	DeleteButton:SetText("Delete Item");
	DeleteButton:SetScript("OnClick", function (self, button, down)
		DeleteItem(deletefield, UpgradeListMainFrame, ViewPrimarySpec, ViewSecondarySpec, statusbarfont, tableUL);
	end);
	
	--"Delete Item" field
	local deletefield = CreateFrame('EditBox', "deletefield", OptionsFrame, "InputBoxTemplate");
	deletefield:SetPoint("TOP", DeletingHeadingFont, "BOTTOM", 0, 0);
	deletefield:SetAutoFocus(false);
	deletefield:SetWidth(25);
	deletefield:SetHeight(24);
	
	--Status Bar
	local PaneBackdrop  = {
		bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true, tileSize = 16, edgeSize = 16,
		insets = { left = 3, right = 3, top = 5, bottom = 3 }
	}
	
	local statusbar = CreateFrame("Frame", "Status Bar", OptionsFrame)
	statusbar:SetPoint("BOTTOMLEFT", OptionsFrame, "BOTTOMLEFT", 15, 15)
	statusbar:SetPoint("BOTTOMRIGHT", OptionsFrame, "BOTTOMRIGHT", -15, 15)
	statusbar:SetHeight(24)
	statusbar:SetBackdrop(PaneBackdrop)
	statusbar:SetBackdropColor(0.1,0.1,0.1)
	statusbar:SetBackdropBorderColor(0.4,0.4,0.4)
	
	statusbarfont = statusbar:CreateFontString("statusbar", "ARTWORK", "GameFontWhite");
	statusbarfont:SetPoint("LEFT", statusbar, "LEFT", 7, 0);
	statusbarfont:SetHeight(22);
	statusbarfont:SetText("UpgradeList v " .. UPGRADELIST_VERSION);
	
	--Frame for entering the number of points needed for certain items.
	local PointInput = CreateFrame("Frame", "PointInput", UIParent);
	PointInput:SetFrameStrata("FULLSCREEN");
	PointInput:SetWidth(250);
	PointInput:SetHeight(200);
	
	PointInput:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", 
	edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",
	tile = true, tileSize = 32, edgeSize = 32, 
	insets = { left = 11, right = 11, top = 10, bottom = 10 }});

	PointInput:SetBackdropColor(0,0,0,1);
	PointInput:SetPoint("CENTER", UIParent, "CENTER");
	
	PointInput:Hide();
	
	local PointInputHeading = CreateFrame('Frame', "PointInputHeading", PointInput);
	PointInputFont = PointInputHeading:CreateFontString("PointInputHeading", "ARTWORK", "GameFontNormal");
	PointInputFont:SetText("Enter the number of Valor Points needed for this item:");
	PointInputFont:SetJustifyH("CENTER");
	PointInputFont:SetPoint("TOP", PointInput, "TOP", 0, -15);
	PointInputFont:SetWidth(230);
	PointInputFont:SetHeight(PointInputFont:GetStringHeight());
	
	local PointInputBox = CreateFrame("Editbox", "PointInputBox", PointInput, "InputBoxTemplate");
	PointInputBox:SetPoint("CENTER", PointInput, "CENTER", 0, 0);
	PointInputBox:SetAutoFocus(true);
	PointInputBox:SetWidth(175);
	PointInputBox:SetHeight(27);
	PointInputBox:SetNumeric(1);
	PointInputBox:SetMaxLetters(5);
	
	local PointInputOK = CreateFrame('Button', "PointInputOK", PointInput, "UIPanelButtonTemplate");
	PointInputOK:SetPoint("BOTTOM", PointInput, "BOTTOM", -50, 20);
	PointInputOK:SetWidth(100);
	PointInputOK:SetHeight(24);
	PointInputOK:SetText("Ok");
	PointInputOK:SetScript("OnClick", function (self, button, down)
		local pointnum = tonumber(PointInputBox:GetText());
		if pointnum == nil then
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("No number entered.");
		elseif pointnum >= 0 then
			pointnum = math.floor(pointnum);
			UIDropDownMenu_SetText(DropDown_Button, UIDropDownMenu_GetSelectedName(DropDown_Button));
			PointInput:Hide();
			PointInputBox:SetText("");
			UPGRADELIST_SELECTEDBOSS = pointnum;
			UPGRADELIST_SELECTEDINSTANCE = UIDropDownMenu_GetSelectedName(DropDown_Button);
			UpgradeListMainFrame:EnableMouse(true)
			CloseButton:EnableMouse(true)
			ToggleButton:EnableMouse(true)
			ViewPrimarySpec:EnableMouse(true)
			ViewSecondarySpec:EnableMouse(true)
			OptionsFrame:EnableMouse(true)
			ItemEntryBox:EnableMouse(true)
			DropDown_Button:EnableMouse(true)
			NoteEntryBox:EnableMouse(true)
			PrimarySpecRadioButton:EnableMouse(true)
			SecondarySpecRadioButton:EnableMouse(true)
			priorityfield:EnableMouse(true)
			AddButton:EnableMouse(true)
			tofield:EnableMouse(true)
			fromfield:EnableMouse(true)
			MoveButton:EnableMouse(true)
			DeleteButton:EnableMouse(true)
			deletefield:EnableMouse(true)
		else
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("Invalid number.");
		end
	end);
	
	local PointInputCancel = CreateFrame('Button', "PointInputCancel", PointInput, "UIPanelButtonTemplate");
	PointInputCancel:SetPoint("LEFT", PointInputOK, "RIGHT", 0, 0);
	PointInputCancel:SetWidth(100);
	PointInputCancel:SetHeight(24);
	PointInputCancel:SetText("Cancel");
	PointInputCancel:SetScript("OnClick", function (self, button, down)
		UIDropDownMenu_SetText(DropDown_Button, "Location:");
		PointInput:Hide();
		UpgradeListMainFrame:EnableMouse(true)
		CloseButton:EnableMouse(true)
		ToggleButton:EnableMouse(true)
		ViewPrimarySpec:EnableMouse(true)
		ViewSecondarySpec:EnableMouse(true)
		OptionsFrame:EnableMouse(true)
		ItemEntryBox:EnableMouse(true)
		DropDown_Button:EnableMouse(true)
		NoteEntryBox:EnableMouse(true)
		PrimarySpecRadioButton:EnableMouse(true)
		SecondarySpecRadioButton:EnableMouse(true)
		priorityfield:EnableMouse(true)
		AddButton:EnableMouse(true)
		tofield:EnableMouse(true)
		fromfield:EnableMouse(true)
		MoveButton:EnableMouse(true)
		DeleteButton:EnableMouse(true)
		deletefield:EnableMouse(true)
		PointInputBox:SetText("");
	end);
	
	--Frame for selecting whether a frame is main hand or off hand.
	local WeaponInput = CreateFrame("Frame", "WeaponInput", UIParent);
	WeaponInput:SetFrameStrata("FULLSCREEN");
	WeaponInput:SetWidth(250);
	WeaponInput:SetHeight(200);
	
	WeaponInput:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", 
		edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",
		tile = true, tileSize = 32, edgeSize = 32, 
		insets = { left = 11, right = 11, top = 10, bottom = 10 }});

	WeaponInput:SetBackdropColor(0,0,0,1);
	WeaponInput:SetPoint("CENTER", UIParent, "CENTER");
	
	WeaponInput:Hide();
	
	local WeaponInputHeading = CreateFrame('Frame', "WeaponInputHeading", WeaponInput);
	WeaponInputFont = WeaponInputHeading:CreateFontString("WeaponInputHeading", "ARTWORK", "GameFontNormal");
	WeaponInputFont:SetText("Select which list to add this item:");
	WeaponInputFont:SetJustifyH("CENTER");
	WeaponInputFont:SetPoint("TOP", WeaponInput, "TOP", 0, -15);
	WeaponInputFont:SetWidth(230);
	WeaponInputFont:SetHeight(WeaponInputFont:GetStringHeight());
	
	--Main Hand weapon checkbox
	local MainHandCheck = CreateFrame('CheckButton', "MainHandCheck", WeaponInput, "UICheckButtonTemplate");
	MainHandCheck:SetPoint("CENTER", WeaponInput, "CENTER", -30, 25);
	MainHandCheck:SetChecked(true);
	_G[MainHandCheck:GetName() .. "Text"]:SetText("Main Hand");
	MainHandCheck:SetScript("OnClick", function (self, button, down)
		OffHandCheck:SetChecked(false);
		MainHandCheck:SetChecked(true);
	end);
	
	--Off Hand weapon checkbox
	local OffHandCheck = CreateFrame('CheckButton', "OffHandCheck", WeaponInput, "UICheckButtonTemplate");
	OffHandCheck:SetPoint("TOP", MainHandCheck, "BOTTOM", 0, 0);
	OffHandCheck:SetChecked(false);
	_G[OffHandCheck:GetName() .. "Text"]:SetText("Off Hand");
	OffHandCheck:SetScript("OnClick", function (self, button, down)
		OffHandCheck:SetChecked(true);
		MainHandCheck:SetChecked(false);
	end);
	
	local WeaponInputOK = CreateFrame('Button', "WeaponInputOK", WeaponInput, "UIPanelButtonTemplate");
	WeaponInputOK:SetPoint("BOTTOM", WeaponInput, "BOTTOM", -50, 20);
	WeaponInputOK:SetWidth(100);
	WeaponInputOK:SetHeight(24);
	WeaponInputOK:SetText("Ok");
	WeaponInputOK:SetScript("OnClick", function (self, button, down)
		local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(ItemEntryBox:GetText());
		local priorityfieldnum = tonumber(priorityfield:GetText());
		if priorityfieldnum ~= nil then
			priorityfieldnum = math.floor(priorityfieldnum);
		end
		if PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if MainHandCheck:GetChecked() then --If the user selects the Main Hand checkbox
				if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Main.Count then --Priority # entered was blank or bigger than the list of items
					UpgradeListDBVar.char.PrimarySpecList.Main.Row[UpgradeListDBVar.char.PrimarySpecList.Main.Count] = { UpgradeListDBVar.char.PrimarySpecList.Main.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
				elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Main.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Main.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
					for i = UpgradeListDBVar.char.PrimarySpecList.Main.Count, priorityfieldnum, -1 do
						UpgradeListDBVar.char.PrimarySpecList.Main.Row[i][1] = i;
					end
				end
				UpgradeListDBVar.char.PrimarySpecList.Main.Count = UpgradeListDBVar.char.PrimarySpecList.Main.Count + 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Main tab.");
				if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 13) and (ViewPrimarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
					LoadMainItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
				end
				UPGRADELIST_SELECTEDINSTANCE = nil;
				UPGRADELIST_SELECTEDBOSS = nil;
				UPGRADELIST_SELECTEDDIFFICULTY = nil;
				ItemEntryBox:SetText("");
				ItemEntryBox:ClearFocus();
				NoteEntryBox:SetText("");
				NoteEntryBox:ClearFocus();
				priorityfield:SetText("");
				priorityfield:ClearFocus();
				UIDropDownMenu_SetText(DropDown_Button, "Location:");
			elseif OffHandCheck:GetChecked() then --If the user selects the Off Hand checkbox
				if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Off.Count then --Priority # entered was blank or bigger than the list of items
					UpgradeListDBVar.char.PrimarySpecList.Off.Row[UpgradeListDBVar.char.PrimarySpecList.Off.Count] = { UpgradeListDBVar.char.PrimarySpecList.Off.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
				elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Off.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
					table.insert(UpgradeListDBVar.char.PrimarySpecList.Off.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
					for i = UpgradeListDBVar.char.PrimarySpecList.Off.Count, priorityfieldnum, -1 do
						UpgradeListDBVar.char.PrimarySpecList.Off.Row[i][1] = i;
					end
				end
				UpgradeListDBVar.char.PrimarySpecList.Off.Count = UpgradeListDBVar.char.PrimarySpecList.Off.Count + 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Off tab.");
				if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 14) and (ViewPrimarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
					LoadOffItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
				end
				UPGRADELIST_SELECTEDINSTANCE = nil;
				UPGRADELIST_SELECTEDBOSS = nil;
				UPGRADELIST_SELECTEDDIFFICULTY = nil;
				ItemEntryBox:SetText("");
				ItemEntryBox:ClearFocus();
				NoteEntryBox:SetText("");
				NoteEntryBox:ClearFocus();
				priorityfield:SetText("");
				priorityfield:ClearFocus();
				UIDropDownMenu_SetText(DropDown_Button, "Location:");
			else
				--Can't tell if the user selected main hand or off hand checkbox
			end
		else --Adding to Secondary Spec List
			if MainHandCheck:GetChecked() then --If the user selects the Main Hand checkbox
				if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Main.Count then --Priority # entered was blank or bigger than the list of items
					UpgradeListDBVar.char.SecondarySpecList.Main.Row[UpgradeListDBVar.char.SecondarySpecList.Main.Count] = { UpgradeListDBVar.char.SecondarySpecList.Main.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
				elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Main.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Main.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
					for i = UpgradeListDBVar.char.SecondarySpecList.Main.Count, priorityfieldnum, -1 do
						UpgradeListDBVar.char.SecondarySpecList.Main.Row[i][1] = i;
					end
				end
				UpgradeListDBVar.char.SecondarySpecList.Main.Count = UpgradeListDBVar.char.SecondarySpecList.Main.Count + 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Main tab.");
				if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 13) and (ViewSecondarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
					LoadMainItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
				end
				UPGRADELIST_SELECTEDINSTANCE = nil;
				UPGRADELIST_SELECTEDBOSS = nil;
				UPGRADELIST_SELECTEDDIFFICULTY = nil;
				ItemEntryBox:SetText("");
				ItemEntryBox:ClearFocus();
				NoteEntryBox:SetText("");
				NoteEntryBox:ClearFocus();
				priorityfield:SetText("");
				priorityfield:ClearFocus();
				UIDropDownMenu_SetText(DropDown_Button, "Location:");
			elseif OffHandCheck:GetChecked() then --If the user selects the Off Hand checkbox
				if priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.SecondarySpecList.Off.Count then --Priority # entered was blank or bigger than the list of items
					UpgradeListDBVar.char.SecondarySpecList.Off.Row[UpgradeListDBVar.char.SecondarySpecList.Off.Count] = { UpgradeListDBVar.char.SecondarySpecList.Off.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
				elseif priorityfieldnum <= UpgradeListDBVar.char.SecondarySpecList.Off.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
					table.insert(UpgradeListDBVar.char.SecondarySpecList.Off.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
					for i = UpgradeListDBVar.char.SecondarySpecList.Off.Count, priorityfieldnum, -1 do
						UpgradeListDBVar.char.SecondarySpecList.Off.Row[i][1] = i;
					end
				end
				UpgradeListDBVar.char.SecondarySpecList.Off.Count = UpgradeListDBVar.char.SecondarySpecList.Off.Count + 1;
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Off tab.");
				if (PanelTemplates_GetSelectedTab(UpgradeListMainFrame) == 14) and (ViewSecondarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
					LoadOffItems(tableUL, ViewPrimarySpec, ViewSecondarySpec);
				end
				UPGRADELIST_SELECTEDINSTANCE = nil;
				UPGRADELIST_SELECTEDBOSS = nil;
				UPGRADELIST_SELECTEDDIFFICULTY = nil;
				ItemEntryBox:SetText("");
				ItemEntryBox:ClearFocus();
				NoteEntryBox:SetText("");
				NoteEntryBox:ClearFocus();
				priorityfield:SetText("");
				priorityfield:ClearFocus();
				UIDropDownMenu_SetText(DropDown_Button, "Location:");
			else
				statusbarfont:SetTextColor(0, 1, 0);
				statusbarfont:SetText("ERROR: Unable to determine if you selected Main Hand or Off Hand for this weapon");
			end
		end
		WeaponInput:Hide();
		OffHandCheck:SetChecked(false);
		MainHandCheck:SetChecked(true);
		UpgradeListMainFrame:EnableMouse(true)
		CloseButton:EnableMouse(true)
		ToggleButton:EnableMouse(true)
		ViewPrimarySpec:EnableMouse(true)
		ViewSecondarySpec:EnableMouse(true)
		OptionsFrame:EnableMouse(true)
		ItemEntryBox:EnableMouse(true)
		DropDown_Button:EnableMouse(true)
		NoteEntryBox:EnableMouse(true)
		PrimarySpecRadioButton:EnableMouse(true)
		SecondarySpecRadioButton:EnableMouse(true)
		priorityfield:EnableMouse(true)
		AddButton:EnableMouse(true)
		tofield:EnableMouse(true)
		fromfield:EnableMouse(true)
		MoveButton:EnableMouse(true)
		DeleteButton:EnableMouse(true)
		deletefield:EnableMouse(true)
	end);
	
	local WeaponInputCancel = CreateFrame('Button', "WeaponInputCancel", WeaponInput, "UIPanelButtonTemplate");
	WeaponInputCancel:SetPoint("LEFT", WeaponInputOK, "RIGHT", 0, 0);
	WeaponInputCancel:SetWidth(100);
	WeaponInputCancel:SetHeight(24);
	WeaponInputCancel:SetText("Cancel");
	WeaponInputCancel:SetScript("OnClick", function (self, button, down)
		WeaponInput:Hide();
		OffHandCheck:SetChecked(false);
		MainHandCheck:SetChecked(true);
		UpgradeListMainFrame:EnableMouse(true)
		CloseButton:EnableMouse(true)
		ToggleButton:EnableMouse(true)
		ViewPrimarySpec:EnableMouse(true)
		ViewSecondarySpec:EnableMouse(true)
		OptionsFrame:EnableMouse(true)
		ItemEntryBox:EnableMouse(true)
		DropDown_Button:EnableMouse(true)
		NoteEntryBox:EnableMouse(true)
		PrimarySpecRadioButton:EnableMouse(true)
		SecondarySpecRadioButton:EnableMouse(true)
		priorityfield:EnableMouse(true)
		AddButton:EnableMouse(true)
		tofield:EnableMouse(true)
		fromfield:EnableMouse(true)
		MoveButton:EnableMouse(true)
		DeleteButton:EnableMouse(true)
		deletefield:EnableMouse(true)
	end);
	UpgradeListMainFrame:Hide();
end